/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of TokyoCabinet.xs. Do not edit this file, edit TokyoCabinet.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "TokyoCabinet.xs"
/*************************************************************************************************
 * Perl binding of Tokyo Cabinet
 *                                                               Copyright (C) 2006-2010 FAL Labs
 * This file is part of Tokyo Cabinet.
 * Tokyo Cabinet is free software; you can redistribute it and/or modify it under the terms of
 * the GNU Lesser General Public License as published by the Free Software Foundation; either
 * version 2.1 of the License or any later version.  Tokyo Cabinet is distributed in the hope
 * that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
 * License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with Tokyo
 * Cabinet; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA.
 *************************************************************************************************/


#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include <tcutil.h>
#include <tchdb.h>
#include <tcbdb.h>
#include <tcfdb.h>
#include <tctdb.h>
#include <tcadb.h>
#include <stdlib.h>
#include <time.h>
#include <stdbool.h>
#include <stdint.h>
#include <math.h>


static int bdb_cmp(const char *aptr, int asiz, const char *bptr, int bsiz, SV *cmp){
  int rv;
  dSP;
  ENTER;
  SAVETMPS;
  PUSHMARK(SP);
  XPUSHs(sv_2mortal(newSVpvn(aptr, asiz)));
  XPUSHs(sv_2mortal(newSVpvn(bptr, bsiz)));
  PUTBACK;
  rv = call_sv(cmp, G_SCALAR);
  SPAGAIN;
  rv = (rv == 1) ? POPi : 0;
  PUTBACK;
  FREETMPS;
  LEAVE;
  return rv;
}


static int tdbqry_proc(const void *pkbuf, int pksiz, TCMAP *tcols, SV *proc){
  HV *cols;
  SV *sv;
  const char *kbuf, *vbuf;
  char *rkbuf, *rvbuf;
  int ksiz, vsiz, rv;
  STRLEN rvsiz;
  I32 rksiz;
  cols = newHV();
  tcmapiterinit(tcols);
  while((kbuf = tcmapiternext(tcols, &ksiz)) != NULL){
    vbuf = tcmapiterval(kbuf, &vsiz);
    hv_store(cols, kbuf, ksiz, newSVpvn(vbuf, vsiz), 0);
  }
  dSP;
  ENTER;
  SAVETMPS;
  PUSHMARK(SP);
  XPUSHs(sv_2mortal(newSVpvn(pkbuf, pksiz)));
  XPUSHs(sv_2mortal(newRV_inc((SV *)cols)));
  PUTBACK;
  rv = call_sv(proc, G_SCALAR);
  SPAGAIN;
  rv = (rv == 1) ? POPi : 0;
  PUTBACK;
  FREETMPS;
  LEAVE;
  if(rv & TDBQPPUT){
    tcmapclear(tcols);
    hv_iterinit(cols);
    while((sv = hv_iternextsv(cols, &rkbuf, &rksiz)) != NULL){
      rvbuf = SvPV(sv, rvsiz);
      tcmapput(tcols, rkbuf, rksiz, rvbuf, rvsiz);
    }
  }
  SvREFCNT_dec(cols);
  return rv;
}


#line 102 "TokyoCabinet.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 246 "TokyoCabinet.c"

XS_EUPXS(XS_TokyoCabinet_tc_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tc_version)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	const char *	RETVAL;
	dXSTARG;
#line 105 "TokyoCabinet.xs"
	RETVAL = tcversion;
#line 259 "TokyoCabinet.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_tc_atoi); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tc_atoi)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "str");
    {
	char *	str = (char *)SvPV_nolen(ST(0))
;
	double	RETVAL;
	dXSTARG;
#line 114 "TokyoCabinet.xs"
	RETVAL = tcatoi(str);
#line 279 "TokyoCabinet.c"
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_tc_atof); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tc_atof)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "str");
    {
	char *	str = (char *)SvPV_nolen(ST(0))
;
	double	RETVAL;
	dXSTARG;
#line 123 "TokyoCabinet.xs"
	RETVAL = tcatof(str);
#line 299 "TokyoCabinet.c"
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_tc_bercompress); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tc_bercompress)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0)
;
#line 132 "TokyoCabinet.xs"
	AV *av;
	unsigned char *buf, *wp;
	int i, len;
	unsigned int num;
#line 320 "TokyoCabinet.c"
	SV *	RETVAL;
#line 137 "TokyoCabinet.xs"
	av = (AV *)SvRV(sv);
	len = av_len(av) + 1;
	buf = tcmalloc(len * 5 + 1);
	wp = buf;
	for(i = 0; i < len; i++){
	  num = SvIV(*av_fetch(av, i, 0));
	  if(num < (1 << 7)){
	    *(wp++) = num;
	  } else if(num < (1 << 14)){
	    *(wp++) = (num >> 7) | 0x80;
	    *(wp++) = num & 0x7f;
	  } else if(num < (1 << 21)){
	    *(wp++) = (num >> 14) | 0x80;
	    *(wp++) = ((num >> 7) & 0x7f) | 0x80;
	    *(wp++) = num & 0x7f;
	  } else if(num < (1 << 28)){
	    *(wp++) = (num >> 21) | 0x80;
	    *(wp++) = ((num >> 14) & 0x7f) | 0x80;
	    *(wp++) = ((num >> 7) & 0x7f) | 0x80;
	    *(wp++) = num & 0x7f;
	  } else {
	    *(wp++) = (num >> 28) | 0x80;
	    *(wp++) = ((num >> 21) & 0x7f) | 0x80;
	    *(wp++) = ((num >> 14) & 0x7f) | 0x80;
	    *(wp++) = ((num >> 7) & 0x7f) | 0x80;
	    *(wp++) = num & 0x7f;
	  }
	}
	RETVAL = newRV_noinc(newSVpvn((char *)buf, wp - buf));
	tcfree(buf);
#line 353 "TokyoCabinet.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_tc_beruncompress); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tc_beruncompress)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0)
;
#line 175 "TokyoCabinet.xs"
	AV *av;
	const unsigned char *ptr;
	STRLEN size;
	unsigned int left, c, num;
#line 375 "TokyoCabinet.c"
	AV *	RETVAL;
#line 180 "TokyoCabinet.xs"
	av = newAV();
	sv = SvRV(sv);
	ptr = (unsigned char *)SvPV(sv, size);
	left = size;
	while(left > 0){
	  num = 0;
	  do {
	    c = *ptr;
	    num = num * 0x80 + (c & 0x7f);
	    ptr++;
	    left--;
	  } while(c >= 0x80);
	  av_push(av, newSViv(num));
	}
	RETVAL = (AV *)sv_2mortal((SV *)av);
#line 393 "TokyoCabinet.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_tc_diffcompress); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tc_diffcompress)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0)
;
#line 203 "TokyoCabinet.xs"
	AV *av;
	unsigned char *buf, *wp;
	int i, len;
	unsigned int lnum, num, tnum;
#line 419 "TokyoCabinet.c"
	SV *	RETVAL;
#line 208 "TokyoCabinet.xs"
	av = (AV *)SvRV(sv);
	len = av_len(av) + 1;
	lnum = 0;
	buf = tcmalloc(len * 5 + 1);
	wp = buf;
	for(i = 0; i < len; i++){
	  num = SvIV(*av_fetch(av, i, 0));
	  tnum = num;
	  num -= lnum;
	  if(num < (1 << 7)){
	    *(wp++) = num;
	  } else if(num < (1 << 14)){
	    *(wp++) = (num >> 7) | 0x80;
	    *(wp++) = num & 0x7f;
	  } else if(num < (1 << 21)){
	    *(wp++) = (num >> 14) | 0x80;
	    *(wp++) = ((num >> 7) & 0x7f) | 0x80;
	    *(wp++) = num & 0x7f;
	  } else if(num < (1 << 28)){
	    *(wp++) = (num >> 21) | 0x80;
	    *(wp++) = ((num >> 14) & 0x7f) | 0x80;
	    *(wp++) = ((num >> 7) & 0x7f) | 0x80;
	    *(wp++) = num & 0x7f;
	  } else {
	    *(wp++) = (num >> 28) | 0x80;
	    *(wp++) = ((num >> 21) & 0x7f) | 0x80;
	    *(wp++) = ((num >> 14) & 0x7f) | 0x80;
	    *(wp++) = ((num >> 7) & 0x7f) | 0x80;
	    *(wp++) = num & 0x7f;
	  }
	  lnum = tnum;
	}
	RETVAL = newRV_noinc(newSVpvn((char *)buf, wp - buf));
	tcfree(buf);
#line 456 "TokyoCabinet.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_tc_diffuncompress); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tc_diffuncompress)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0)
;
#line 250 "TokyoCabinet.xs"
	AV *av;
	const unsigned char *ptr;
	STRLEN size;
	unsigned int left, c, num, sum;
#line 478 "TokyoCabinet.c"
	AV *	RETVAL;
#line 255 "TokyoCabinet.xs"
	av = newAV();
	sv = SvRV(sv);
	ptr = (unsigned char *)SvPV(sv, size);
	left = size;
	sum = 0;
	while(left > 0){
	  num = 0;
	  do {
	    c = *ptr;
	    num = num * 0x80 + (c & 0x7f);
	    ptr++;
	    left--;
	  } while(c >= 0x80);
	  sum += num;
	  av_push(av, newSViv(sum));
	}
	RETVAL = (AV *)sv_2mortal((SV *)av);
#line 498 "TokyoCabinet.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_tc_strdistance); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tc_strdistance)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "asv, bsv, isutf");
    {
	SV *	asv = ST(0)
;
	SV *	bsv = ST(1)
;
	int	isutf = (int)SvIV(ST(2))
;
#line 282 "TokyoCabinet.xs"
	const char *astr, *bstr;
#line 525 "TokyoCabinet.c"
	int	RETVAL;
	dXSTARG;
#line 284 "TokyoCabinet.xs"
	asv = SvRV(asv);
	astr = SvPV_nolen(asv);
	bsv = SvRV(bsv);
	bstr = SvPV_nolen(bsv);
	RETVAL = isutf ? tcstrdistutf(astr, bstr) : tcstrdist(astr, bstr);
#line 534 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_hdb_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_hdb_new)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 302 "TokyoCabinet.xs"
	TCHDB *hdb;
#line 550 "TokyoCabinet.c"
	void *	RETVAL;
	dXSTARG;
#line 304 "TokyoCabinet.xs"
	hdb = tchdbnew();
	tchdbsetmutex(hdb);
	RETVAL = hdb;
#line 557 "TokyoCabinet.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_hdb_del); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_hdb_del)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "hdb");
    {
	void *	hdb = INT2PTR(void *,SvIV(ST(0)))
;
#line 315 "TokyoCabinet.xs"
	tchdbdel(hdb);
#line 575 "TokyoCabinet.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_TokyoCabinet_hdb_errmsg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_hdb_errmsg)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ecode");
    {
	int	ecode = (int)SvIV(ST(0))
;
	const char *	RETVAL;
	dXSTARG;
#line 322 "TokyoCabinet.xs"
	RETVAL = tchdberrmsg(ecode);
#line 594 "TokyoCabinet.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_hdb_ecode); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_hdb_ecode)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "hdb");
    {
	void *	hdb = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 331 "TokyoCabinet.xs"
	RETVAL = tchdbecode(hdb);
#line 614 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_hdb_tune); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_hdb_tune)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "hdb, bnum, apow, fpow, opts");
    {
	void *	hdb = INT2PTR(void *,SvIV(ST(0)))
;
	double	bnum = (double)SvNV(ST(1))
;
	int	apow = (int)SvIV(ST(2))
;
	int	fpow = (int)SvIV(ST(3))
;
	int	opts = (int)SvIV(ST(4))
;
	int	RETVAL;
	dXSTARG;
#line 344 "TokyoCabinet.xs"
	RETVAL = tchdbtune(hdb, bnum, apow, fpow, opts);
#line 642 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_hdb_setcache); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_hdb_setcache)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "hdb, rcnum");
    {
	void *	hdb = INT2PTR(void *,SvIV(ST(0)))
;
	int	rcnum = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;
#line 354 "TokyoCabinet.xs"
	RETVAL = tchdbsetcache(hdb, rcnum);
#line 664 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_hdb_setxmsiz); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_hdb_setxmsiz)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "hdb, xmsiz");
    {
	void *	hdb = INT2PTR(void *,SvIV(ST(0)))
;
	double	xmsiz = (double)SvNV(ST(1))
;
	int	RETVAL;
	dXSTARG;
#line 364 "TokyoCabinet.xs"
	RETVAL = tchdbsetxmsiz(hdb, xmsiz);
#line 686 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_hdb_setdfunit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_hdb_setdfunit)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "hdb, dfunit");
    {
	void *	hdb = INT2PTR(void *,SvIV(ST(0)))
;
	int	dfunit = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;
#line 374 "TokyoCabinet.xs"
	RETVAL = tchdbsetdfunit(hdb, dfunit);
#line 708 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_hdb_open); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_hdb_open)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "hdb, path, omode");
    {
	void *	hdb = INT2PTR(void *,SvIV(ST(0)))
;
	char *	path = (char *)SvPV_nolen(ST(1))
;
	int	omode = (int)SvIV(ST(2))
;
	int	RETVAL;
	dXSTARG;
#line 385 "TokyoCabinet.xs"
	RETVAL = tchdbopen(hdb, path, omode);
#line 732 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_hdb_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_hdb_close)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "hdb");
    {
	void *	hdb = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 394 "TokyoCabinet.xs"
	RETVAL = tchdbclose(hdb);
#line 752 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_hdb_put); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_hdb_put)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "hdb, key, val");
    {
	void *	hdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	key = ST(1)
;
	SV *	val = ST(2)
;
#line 405 "TokyoCabinet.xs"
	const char *kbuf, *vbuf;
	STRLEN ksiz, vsiz;
#line 775 "TokyoCabinet.c"
	int	RETVAL;
	dXSTARG;
#line 408 "TokyoCabinet.xs"
	kbuf = SvPV(key, ksiz);
	vbuf = SvPV(val, vsiz);
	RETVAL = tchdbput(hdb, kbuf, (int)ksiz, vbuf, (int)vsiz);
#line 782 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_hdb_putkeep); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_hdb_putkeep)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "hdb, key, val");
    {
	void *	hdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	key = ST(1)
;
	SV *	val = ST(2)
;
#line 421 "TokyoCabinet.xs"
	const char *kbuf, *vbuf;
	STRLEN ksiz, vsiz;
#line 805 "TokyoCabinet.c"
	int	RETVAL;
	dXSTARG;
#line 424 "TokyoCabinet.xs"
	kbuf = SvPV(key, ksiz);
	vbuf = SvPV(val, vsiz);
	RETVAL = tchdbputkeep(hdb, kbuf, (int)ksiz, vbuf, (int)vsiz);
#line 812 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_hdb_putcat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_hdb_putcat)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "hdb, key, val");
    {
	void *	hdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	key = ST(1)
;
	SV *	val = ST(2)
;
#line 437 "TokyoCabinet.xs"
	const char *kbuf, *vbuf;
	STRLEN ksiz, vsiz;
#line 835 "TokyoCabinet.c"
	int	RETVAL;
	dXSTARG;
#line 440 "TokyoCabinet.xs"
	kbuf = SvPV(key, ksiz);
	vbuf = SvPV(val, vsiz);
	RETVAL = tchdbputcat(hdb, kbuf, (int)ksiz, vbuf, (int)vsiz);
#line 842 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_hdb_putasync); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_hdb_putasync)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "hdb, key, val");
    {
	void *	hdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	key = ST(1)
;
	SV *	val = ST(2)
;
#line 453 "TokyoCabinet.xs"
	const char *kbuf, *vbuf;
	STRLEN ksiz, vsiz;
#line 865 "TokyoCabinet.c"
	int	RETVAL;
	dXSTARG;
#line 456 "TokyoCabinet.xs"
	kbuf = SvPV(key, ksiz);
	vbuf = SvPV(val, vsiz);
	RETVAL = tchdbputasync(hdb, kbuf, (int)ksiz, vbuf, (int)vsiz);
#line 872 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_hdb_out); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_hdb_out)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "hdb, key");
    {
	void *	hdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	key = ST(1)
;
#line 468 "TokyoCabinet.xs"
	const char *kbuf;
	STRLEN ksiz;
#line 893 "TokyoCabinet.c"
	int	RETVAL;
	dXSTARG;
#line 471 "TokyoCabinet.xs"
	kbuf = SvPV(key, ksiz);
	RETVAL = tchdbout(hdb, kbuf, (int)ksiz);
#line 899 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_hdb_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_hdb_get)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "hdb, key");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	hdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	key = ST(1)
;
#line 482 "TokyoCabinet.xs"
	const char *kbuf;
	STRLEN ksiz;
	char *vbuf;
	int vsiz;
#line 924 "TokyoCabinet.c"
#line 487 "TokyoCabinet.xs"
	kbuf = SvPV(key, ksiz);
	vbuf = tchdbget(hdb, kbuf, (int)ksiz, &vsiz);
	if(vbuf){
	  XPUSHs(sv_2mortal(newSVpvn(vbuf, vsiz)));
	  tcfree(vbuf);
	} else {
	  XPUSHs((SV *)&PL_sv_undef);
	}
	XSRETURN(1);
#line 935 "TokyoCabinet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_TokyoCabinet_hdb_vsiz); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_hdb_vsiz)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "hdb, key");
    {
	void *	hdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	key = ST(1)
;
#line 503 "TokyoCabinet.xs"
	const char *kbuf;
	STRLEN ksiz;
#line 956 "TokyoCabinet.c"
	int	RETVAL;
	dXSTARG;
#line 506 "TokyoCabinet.xs"
	kbuf = SvPV(key, ksiz);
	RETVAL = tchdbvsiz(hdb, kbuf, (int)ksiz);
#line 962 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_hdb_iterinit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_hdb_iterinit)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "hdb");
    {
	void *	hdb = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 516 "TokyoCabinet.xs"
	RETVAL = tchdbiterinit(hdb);
#line 982 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_hdb_iternext); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_hdb_iternext)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "hdb");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	hdb = INT2PTR(void *,SvIV(ST(0)))
;
#line 525 "TokyoCabinet.xs"
	char *vbuf;
	int vsiz;
#line 1003 "TokyoCabinet.c"
#line 528 "TokyoCabinet.xs"
	vbuf = tchdbiternext(hdb, &vsiz);
	if(vbuf){
	  XPUSHs(sv_2mortal(newSVpvn(vbuf, vsiz)));
	  tcfree(vbuf);
	} else {
	  XPUSHs((SV *)&PL_sv_undef);
	}
	XSRETURN(1);
#line 1013 "TokyoCabinet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_TokyoCabinet_hdb_fwmkeys); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_hdb_fwmkeys)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "hdb, prefix, max");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	hdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	prefix = ST(1)
;
	int	max = (int)SvIV(ST(2))
;
#line 544 "TokyoCabinet.xs"
	AV *av;
	STRLEN psiz;
	TCLIST *keys;
	const char *pbuf, *kbuf;
	int i, ksiz;
#line 1041 "TokyoCabinet.c"
#line 550 "TokyoCabinet.xs"
	pbuf = SvPV(prefix, psiz);
	keys = tchdbfwmkeys(hdb, pbuf, (int)psiz, max);
	av = newAV();
	for(i = 0; i < tclistnum(keys); i++){
	  kbuf = tclistval(keys, i, &ksiz);
	  av_push(av, newSVpvn(kbuf, ksiz));
	}
	tclistdel(keys);
	XPUSHs(sv_2mortal(newRV_noinc((SV *)av)));
	XSRETURN(1);
#line 1053 "TokyoCabinet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_TokyoCabinet_hdb_addint); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_hdb_addint)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "hdb, key, num");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	hdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	key = ST(1)
;
	int	num = (int)SvIV(ST(2))
;
#line 568 "TokyoCabinet.xs"
	const char *kbuf;
	STRLEN ksiz;
#line 1078 "TokyoCabinet.c"
#line 571 "TokyoCabinet.xs"
	kbuf = SvPV(key, ksiz);
	num = tchdbaddint(hdb, kbuf, (int)ksiz, num);
	if(num == INT_MIN){
	  XPUSHs((SV *)&PL_sv_undef);
	} else {
	  XPUSHs(sv_2mortal(newSViv(num)));
	}
	XSRETURN(1);
#line 1088 "TokyoCabinet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_TokyoCabinet_hdb_adddouble); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_hdb_adddouble)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "hdb, key, num");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	hdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	key = ST(1)
;
	double	num = (double)SvNV(ST(2))
;
#line 587 "TokyoCabinet.xs"
	const char *kbuf;
	STRLEN ksiz;
#line 1113 "TokyoCabinet.c"
#line 590 "TokyoCabinet.xs"
	kbuf = SvPV(key, ksiz);
	num = tchdbadddouble(hdb, kbuf, (int)ksiz, num);
	if(isnan(num)){
	  XPUSHs((SV *)&PL_sv_undef);
	} else {
	  XPUSHs(sv_2mortal(newSVnv(num)));
	}
	XSRETURN(1);
#line 1123 "TokyoCabinet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_TokyoCabinet_hdb_sync); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_hdb_sync)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "hdb");
    {
	void *	hdb = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 604 "TokyoCabinet.xs"
	RETVAL = tchdbsync(hdb);
#line 1143 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_hdb_optimize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_hdb_optimize)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "hdb, bnum, apow, fpow, opts");
    {
	void *	hdb = INT2PTR(void *,SvIV(ST(0)))
;
	double	bnum = (double)SvNV(ST(1))
;
	int	apow = (int)SvIV(ST(2))
;
	int	fpow = (int)SvIV(ST(3))
;
	int	opts = (int)SvIV(ST(4))
;
	int	RETVAL;
	dXSTARG;
#line 617 "TokyoCabinet.xs"
	RETVAL = tchdboptimize(hdb, bnum, apow, fpow, opts);
#line 1171 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_hdb_vanish); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_hdb_vanish)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "hdb");
    {
	void *	hdb = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 626 "TokyoCabinet.xs"
	RETVAL = tchdbvanish(hdb);
#line 1191 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_hdb_copy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_hdb_copy)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "hdb, path");
    {
	void *	hdb = INT2PTR(void *,SvIV(ST(0)))
;
	char *	path = (char *)SvPV_nolen(ST(1))
;
	int	RETVAL;
	dXSTARG;
#line 636 "TokyoCabinet.xs"
	RETVAL = tchdbcopy(hdb, path);
#line 1213 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_hdb_tranbegin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_hdb_tranbegin)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "hdb");
    {
	void *	hdb = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 645 "TokyoCabinet.xs"
	RETVAL = tchdbtranbegin(hdb);
#line 1233 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_hdb_trancommit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_hdb_trancommit)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "hdb");
    {
	void *	hdb = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 654 "TokyoCabinet.xs"
	RETVAL = tchdbtrancommit(hdb);
#line 1253 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_hdb_tranabort); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_hdb_tranabort)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "hdb");
    {
	void *	hdb = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 663 "TokyoCabinet.xs"
	RETVAL = tchdbtranabort(hdb);
#line 1273 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_hdb_path); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_hdb_path)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "hdb");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	hdb = INT2PTR(void *,SvIV(ST(0)))
;
#line 672 "TokyoCabinet.xs"
	const char *path;
#line 1293 "TokyoCabinet.c"
#line 674 "TokyoCabinet.xs"
	path = tchdbpath(hdb);
	if(path){
	  XPUSHs(sv_2mortal(newSVpv(path, 0)));
	} else {
	  XPUSHs((SV *)&PL_sv_undef);
	}
	XSRETURN(1);
#line 1302 "TokyoCabinet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_TokyoCabinet_hdb_rnum); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_hdb_rnum)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "hdb");
    {
	void *	hdb = INT2PTR(void *,SvIV(ST(0)))
;
	double	RETVAL;
	dXSTARG;
#line 687 "TokyoCabinet.xs"
	RETVAL = tchdbrnum(hdb);
#line 1322 "TokyoCabinet.c"
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_hdb_fsiz); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_hdb_fsiz)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "hdb");
    {
	void *	hdb = INT2PTR(void *,SvIV(ST(0)))
;
	double	RETVAL;
	dXSTARG;
#line 696 "TokyoCabinet.xs"
	RETVAL = tchdbfsiz(hdb);
#line 1342 "TokyoCabinet.c"
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_bdb_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdb_new)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 710 "TokyoCabinet.xs"
	TCBDB *bdb;
#line 1358 "TokyoCabinet.c"
	void *	RETVAL;
	dXSTARG;
#line 712 "TokyoCabinet.xs"
	bdb = tcbdbnew();
	tcbdbsetmutex(bdb);
	RETVAL = bdb;
#line 1365 "TokyoCabinet.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_bdb_del); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdb_del)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "bdb");
    {
	void *	bdb = INT2PTR(void *,SvIV(ST(0)))
;
#line 723 "TokyoCabinet.xs"
	SV *cmp;
#line 1383 "TokyoCabinet.c"
#line 725 "TokyoCabinet.xs"
	cmp = tcbdbcmpop(bdb);
	if(cmp) SvREFCNT_dec(cmp);
	tcbdbdel(bdb);
#line 1388 "TokyoCabinet.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_TokyoCabinet_bdb_errmsg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdb_errmsg)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ecode");
    {
	int	ecode = (int)SvIV(ST(0))
;
	const char *	RETVAL;
	dXSTARG;
#line 734 "TokyoCabinet.xs"
	RETVAL = tcbdberrmsg(ecode);
#line 1407 "TokyoCabinet.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_bdb_ecode); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdb_ecode)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "bdb");
    {
	void *	bdb = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 743 "TokyoCabinet.xs"
	RETVAL = tcbdbecode(bdb);
#line 1427 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_bdb_setcmpfunc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdb_setcmpfunc)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "bdb, num");
    {
	void *	bdb = INT2PTR(void *,SvIV(ST(0)))
;
	int	num = (int)SvIV(ST(1))
;
#line 753 "TokyoCabinet.xs"
	SV *ocmp;
#line 1447 "TokyoCabinet.c"
	int	RETVAL;
	dXSTARG;
#line 755 "TokyoCabinet.xs"
	ocmp = tcbdbcmpop(bdb);
	if(ocmp) SvREFCNT_dec(ocmp);
	switch(num){
	case 1: RETVAL = tcbdbsetcmpfunc(bdb, tccmpdecimal, NULL); break;
	case 2: RETVAL = tcbdbsetcmpfunc(bdb, tccmpint32, NULL); break;
	case 3: RETVAL = tcbdbsetcmpfunc(bdb, tccmpint64, NULL); break;
	default: RETVAL = tcbdbsetcmpfunc(bdb, tccmplexical, NULL); break;
	}
#line 1459 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_bdb_setcmpfuncex); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdb_setcmpfuncex)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "bdb, cmp");
    {
	void *	bdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	cmp = ST(1)
;
#line 772 "TokyoCabinet.xs"
	SV *ocmp;
#line 1479 "TokyoCabinet.c"
	int	RETVAL;
	dXSTARG;
#line 774 "TokyoCabinet.xs"
	ocmp = tcbdbcmpop(bdb);
	if(ocmp) SvREFCNT_dec(ocmp);
	RETVAL = tcbdbsetcmpfunc(bdb, (TCCMP)bdb_cmp, newSVsv(cmp));
#line 1486 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_bdb_tune); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdb_tune)
{
    dVAR; dXSARGS;
    if (items != 7)
       croak_xs_usage(cv,  "bdb, lmemb, nmemb, bnum, apow, fpow, opts");
    {
	void *	bdb = INT2PTR(void *,SvIV(ST(0)))
;
	int	lmemb = (int)SvIV(ST(1))
;
	int	nmemb = (int)SvIV(ST(2))
;
	double	bnum = (double)SvNV(ST(3))
;
	int	apow = (int)SvIV(ST(4))
;
	int	fpow = (int)SvIV(ST(5))
;
	int	opts = (int)SvIV(ST(6))
;
	int	RETVAL;
	dXSTARG;
#line 791 "TokyoCabinet.xs"
	RETVAL = tcbdbtune(bdb, lmemb, nmemb, bnum, apow, fpow, opts);
#line 1518 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_bdb_setcache); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdb_setcache)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "bdb, lcnum, ncnum");
    {
	void *	bdb = INT2PTR(void *,SvIV(ST(0)))
;
	int	lcnum = (int)SvIV(ST(1))
;
	int	ncnum = (int)SvIV(ST(2))
;
	int	RETVAL;
	dXSTARG;
#line 802 "TokyoCabinet.xs"
	RETVAL = tcbdbsetcache(bdb, lcnum, ncnum);
#line 1542 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_bdb_setxmsiz); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdb_setxmsiz)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "bdb, xmsiz");
    {
	void *	bdb = INT2PTR(void *,SvIV(ST(0)))
;
	double	xmsiz = (double)SvNV(ST(1))
;
	int	RETVAL;
	dXSTARG;
#line 812 "TokyoCabinet.xs"
	RETVAL = tcbdbsetxmsiz(bdb, xmsiz);
#line 1564 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_bdb_setdfunit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdb_setdfunit)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "bdb, dfunit");
    {
	void *	bdb = INT2PTR(void *,SvIV(ST(0)))
;
	int	dfunit = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;
#line 822 "TokyoCabinet.xs"
	RETVAL = tcbdbsetdfunit(bdb, dfunit);
#line 1586 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_bdb_open); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdb_open)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "bdb, path, omode");
    {
	void *	bdb = INT2PTR(void *,SvIV(ST(0)))
;
	char *	path = (char *)SvPV_nolen(ST(1))
;
	int	omode = (int)SvIV(ST(2))
;
	int	RETVAL;
	dXSTARG;
#line 833 "TokyoCabinet.xs"
	RETVAL = tcbdbopen(bdb, path, omode);
#line 1610 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_bdb_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdb_close)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "bdb");
    {
	void *	bdb = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 842 "TokyoCabinet.xs"
	RETVAL = tcbdbclose(bdb);
#line 1630 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_bdb_put); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdb_put)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "bdb, key, val");
    {
	void *	bdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	key = ST(1)
;
	SV *	val = ST(2)
;
#line 853 "TokyoCabinet.xs"
	const char *kbuf, *vbuf;
	STRLEN ksiz, vsiz;
#line 1653 "TokyoCabinet.c"
	int	RETVAL;
	dXSTARG;
#line 856 "TokyoCabinet.xs"
	kbuf = SvPV(key, ksiz);
	vbuf = SvPV(val, vsiz);
	RETVAL = tcbdbput(bdb, kbuf, (int)ksiz, vbuf, (int)vsiz);
#line 1660 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_bdb_putkeep); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdb_putkeep)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "bdb, key, val");
    {
	void *	bdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	key = ST(1)
;
	SV *	val = ST(2)
;
#line 869 "TokyoCabinet.xs"
	const char *kbuf, *vbuf;
	STRLEN ksiz, vsiz;
#line 1683 "TokyoCabinet.c"
	int	RETVAL;
	dXSTARG;
#line 872 "TokyoCabinet.xs"
	kbuf = SvPV(key, ksiz);
	vbuf = SvPV(val, vsiz);
	RETVAL = tcbdbputkeep(bdb, kbuf, (int)ksiz, vbuf, (int)vsiz);
#line 1690 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_bdb_putcat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdb_putcat)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "bdb, key, val");
    {
	void *	bdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	key = ST(1)
;
	SV *	val = ST(2)
;
#line 885 "TokyoCabinet.xs"
	const char *kbuf, *vbuf;
	STRLEN ksiz, vsiz;
#line 1713 "TokyoCabinet.c"
	int	RETVAL;
	dXSTARG;
#line 888 "TokyoCabinet.xs"
	kbuf = SvPV(key, ksiz);
	vbuf = SvPV(val, vsiz);
	RETVAL = tcbdbputcat(bdb, kbuf, (int)ksiz, vbuf, (int)vsiz);
#line 1720 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_bdb_putdup); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdb_putdup)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "bdb, key, val");
    {
	void *	bdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	key = ST(1)
;
	SV *	val = ST(2)
;
#line 901 "TokyoCabinet.xs"
	const char *kbuf, *vbuf;
	STRLEN ksiz, vsiz;
#line 1743 "TokyoCabinet.c"
	int	RETVAL;
	dXSTARG;
#line 904 "TokyoCabinet.xs"
	kbuf = SvPV(key, ksiz);
	vbuf = SvPV(val, vsiz);
	RETVAL = tcbdbputdup(bdb, kbuf, (int)ksiz, vbuf, (int)vsiz);
#line 1750 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_bdb_putlist); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdb_putlist)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "bdb, key, vals");
    {
	void *	bdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	key = ST(1)
;
	AV *	vals;
#line 917 "TokyoCabinet.xs"
	SV *val;
	TCLIST *tvals;
	const char *kbuf, *vbuf;
	STRLEN ksiz, vsiz;
	int i, num;
#line 1775 "TokyoCabinet.c"
	int	RETVAL;
	dXSTARG;

	STMT_START {
		SV* const xsub_tmp_sv = ST(2);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    vals = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"TokyoCabinet::bdb_putlist",
				"vals");
		}
	} STMT_END
;
#line 923 "TokyoCabinet.xs"
	kbuf = SvPV(key, ksiz);
	tvals = tclistnew();
	num = av_len(vals) + 1;
	for(i = 0; i < num; i++){
	  val = *av_fetch(vals, i, 0);
	  vbuf = SvPV(val, vsiz);
	  tclistpush(tvals, vbuf, (int)vsiz);
	}
	RETVAL = tcbdbputdup3(bdb, kbuf, (int)ksiz, tvals);
	tclistdel(tvals);
#line 1803 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_bdb_out); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdb_out)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "bdb, key");
    {
	void *	bdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	key = ST(1)
;
#line 942 "TokyoCabinet.xs"
	const char *kbuf;
	STRLEN ksiz;
#line 1824 "TokyoCabinet.c"
	int	RETVAL;
	dXSTARG;
#line 945 "TokyoCabinet.xs"
	kbuf = SvPV(key, ksiz);
	RETVAL = tcbdbout(bdb, kbuf, (int)ksiz);
#line 1830 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_bdb_outlist); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdb_outlist)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "bdb, key");
    {
	void *	bdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	key = ST(1)
;
#line 956 "TokyoCabinet.xs"
	const char *kbuf;
	STRLEN ksiz;
#line 1851 "TokyoCabinet.c"
	int	RETVAL;
	dXSTARG;
#line 959 "TokyoCabinet.xs"
	kbuf = SvPV(key, ksiz);
	RETVAL = tcbdbout3(bdb, kbuf, (int)ksiz);
#line 1857 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_bdb_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdb_get)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "bdb, key");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	bdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	key = ST(1)
;
#line 970 "TokyoCabinet.xs"
	const char *kbuf;
	STRLEN ksiz;
	char *vbuf;
	int vsiz;
#line 1882 "TokyoCabinet.c"
#line 975 "TokyoCabinet.xs"
	kbuf = SvPV(key, ksiz);
	vbuf = tcbdbget(bdb, kbuf, (int)ksiz, &vsiz);
	if(vbuf){
	  XPUSHs(sv_2mortal(newSVpvn(vbuf, vsiz)));
	  tcfree(vbuf);
	} else {
	  XPUSHs((SV *)&PL_sv_undef);
	}
	XSRETURN(1);
#line 1893 "TokyoCabinet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_TokyoCabinet_bdb_getlist); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdb_getlist)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "bdb, key");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	bdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	key = ST(1)
;
#line 991 "TokyoCabinet.xs"
	AV *av;
	TCLIST *vals;
	const char *kbuf, *vbuf;
	STRLEN ksiz;
	int i, vsiz;
#line 1919 "TokyoCabinet.c"
#line 997 "TokyoCabinet.xs"
	kbuf = SvPV(key, ksiz);
	vals = tcbdbget4(bdb, kbuf, (int)ksiz);
	if(vals){
	  av = newAV();
	  for(i = 0; i < tclistnum(vals); i++){
	    vbuf = tclistval(vals, i, &vsiz);
	    av_push(av, newSVpvn(vbuf, vsiz));
	  }
	  tclistdel(vals);
	  XPUSHs(sv_2mortal(newRV_noinc((SV *)av)));
	} else {
	  XPUSHs((SV *)&PL_sv_undef);
	}
	XSRETURN(1);
#line 1935 "TokyoCabinet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_TokyoCabinet_bdb_vnum); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdb_vnum)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "bdb, key");
    {
	void *	bdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	key = ST(1)
;
#line 1018 "TokyoCabinet.xs"
	const char *kbuf;
	STRLEN ksiz;
#line 1956 "TokyoCabinet.c"
	int	RETVAL;
	dXSTARG;
#line 1021 "TokyoCabinet.xs"
	kbuf = SvPV(key, ksiz);
	RETVAL = tcbdbvnum(bdb, kbuf, (int)ksiz);
#line 1962 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_bdb_vsiz); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdb_vsiz)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "bdb, key");
    {
	void *	bdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	key = ST(1)
;
#line 1032 "TokyoCabinet.xs"
	const char *kbuf;
	STRLEN ksiz;
#line 1983 "TokyoCabinet.c"
	int	RETVAL;
	dXSTARG;
#line 1035 "TokyoCabinet.xs"
	kbuf = SvPV(key, ksiz);
	RETVAL = tcbdbvsiz(bdb, kbuf, (int)ksiz);
#line 1989 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_bdb_range); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdb_range)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "bdb, bkey, binc, ekey, einc, max");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	bdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	bkey = ST(1)
;
	int	binc = (int)SvIV(ST(2))
;
	SV *	ekey = ST(3)
;
	int	einc = (int)SvIV(ST(4))
;
	int	max = (int)SvIV(ST(5))
;
#line 1050 "TokyoCabinet.xs"
	AV *av;
	TCLIST *keys;
	const char *bkbuf, *ekbuf, *kbuf;
	STRLEN bksiz, eksiz;
	int i, ksiz;
#line 2023 "TokyoCabinet.c"
#line 1056 "TokyoCabinet.xs"
	if(bkey){
	  bkbuf = SvPV(bkey, bksiz);
	} else {
	  bkbuf = NULL;
	  bksiz = -1;
	}
	if(ekey){
	  ekbuf = SvPV(ekey, eksiz);
	} else {
	  ekbuf = NULL;
	  eksiz = -1;
	}
	keys = tcbdbrange(bdb, bkbuf, (int)bksiz, binc, ekbuf, (int)eksiz, einc, max);
	av = newAV();
	for(i = 0; i < tclistnum(keys); i++){
	  kbuf = tclistval(keys, i, &ksiz);
	  av_push(av, newSVpvn(kbuf, ksiz));
	}
	tclistdel(keys);
	XPUSHs(sv_2mortal(newRV_noinc((SV *)av)));
	XSRETURN(1);
#line 2046 "TokyoCabinet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_TokyoCabinet_bdb_fwmkeys); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdb_fwmkeys)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "bdb, prefix, max");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	bdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	prefix = ST(1)
;
	int	max = (int)SvIV(ST(2))
;
#line 1085 "TokyoCabinet.xs"
	AV *av;
	STRLEN psiz;
	TCLIST *keys;
	const char *pbuf, *kbuf;
	int i, ksiz;
#line 2074 "TokyoCabinet.c"
#line 1091 "TokyoCabinet.xs"
	pbuf = SvPV(prefix, psiz);
	keys = tcbdbfwmkeys(bdb, pbuf, (int)psiz, max);
	av = newAV();
	for(i = 0; i < tclistnum(keys); i++){
	  kbuf = tclistval(keys, i, &ksiz);
	  av_push(av, newSVpvn(kbuf, ksiz));
	}
	tclistdel(keys);
	XPUSHs(sv_2mortal(newRV_noinc((SV *)av)));
	XSRETURN(1);
#line 2086 "TokyoCabinet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_TokyoCabinet_bdb_addint); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdb_addint)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "bdb, key, num");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	bdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	key = ST(1)
;
	int	num = (int)SvIV(ST(2))
;
#line 1109 "TokyoCabinet.xs"
	const char *kbuf;
	STRLEN ksiz;
#line 2111 "TokyoCabinet.c"
#line 1112 "TokyoCabinet.xs"
	kbuf = SvPV(key, ksiz);
	num = tcbdbaddint(bdb, kbuf, (int)ksiz, num);
	if(num == INT_MIN){
	  XPUSHs((SV *)&PL_sv_undef);
	} else {
	  XPUSHs(sv_2mortal(newSViv(num)));
	}
	XSRETURN(1);
#line 2121 "TokyoCabinet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_TokyoCabinet_bdb_adddouble); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdb_adddouble)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "bdb, key, num");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	bdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	key = ST(1)
;
	double	num = (double)SvNV(ST(2))
;
#line 1128 "TokyoCabinet.xs"
	const char *kbuf;
	STRLEN ksiz;
#line 2146 "TokyoCabinet.c"
#line 1131 "TokyoCabinet.xs"
	kbuf = SvPV(key, ksiz);
	num = tcbdbadddouble(bdb, kbuf, (int)ksiz, num);
	if(isnan(num)){
	  XPUSHs((SV *)&PL_sv_undef);
	} else {
	  XPUSHs(sv_2mortal(newSVnv(num)));
	}
	XSRETURN(1);
#line 2156 "TokyoCabinet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_TokyoCabinet_bdb_sync); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdb_sync)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "bdb");
    {
	void *	bdb = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 1145 "TokyoCabinet.xs"
	RETVAL = tcbdbsync(bdb);
#line 2176 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_bdb_optimize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdb_optimize)
{
    dVAR; dXSARGS;
    if (items != 7)
       croak_xs_usage(cv,  "bdb, lmemb, nmemb, bnum, apow, fpow, opts");
    {
	void *	bdb = INT2PTR(void *,SvIV(ST(0)))
;
	int	lmemb = (int)SvIV(ST(1))
;
	int	nmemb = (int)SvIV(ST(2))
;
	double	bnum = (double)SvNV(ST(3))
;
	int	apow = (int)SvIV(ST(4))
;
	int	fpow = (int)SvIV(ST(5))
;
	int	opts = (int)SvIV(ST(6))
;
	int	RETVAL;
	dXSTARG;
#line 1160 "TokyoCabinet.xs"
	RETVAL = tcbdboptimize(bdb, lmemb, nmemb, bnum, apow, fpow, opts);
#line 2208 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_bdb_vanish); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdb_vanish)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "bdb");
    {
	void *	bdb = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 1169 "TokyoCabinet.xs"
	RETVAL = tcbdbvanish(bdb);
#line 2228 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_bdb_copy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdb_copy)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "bdb, path");
    {
	void *	bdb = INT2PTR(void *,SvIV(ST(0)))
;
	char *	path = (char *)SvPV_nolen(ST(1))
;
	int	RETVAL;
	dXSTARG;
#line 1179 "TokyoCabinet.xs"
	RETVAL = tcbdbcopy(bdb, path);
#line 2250 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_bdb_tranbegin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdb_tranbegin)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "bdb");
    {
	void *	bdb = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 1188 "TokyoCabinet.xs"
	RETVAL = tcbdbtranbegin(bdb);
#line 2270 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_bdb_trancommit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdb_trancommit)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "bdb");
    {
	void *	bdb = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 1197 "TokyoCabinet.xs"
	RETVAL = tcbdbtrancommit(bdb);
#line 2290 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_bdb_tranabort); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdb_tranabort)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "bdb");
    {
	void *	bdb = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 1206 "TokyoCabinet.xs"
	RETVAL = tcbdbtranabort(bdb);
#line 2310 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_bdb_path); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdb_path)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "bdb");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	bdb = INT2PTR(void *,SvIV(ST(0)))
;
#line 1215 "TokyoCabinet.xs"
	const char *path;
#line 2330 "TokyoCabinet.c"
#line 1217 "TokyoCabinet.xs"
	path = tcbdbpath(bdb);
	if(path){
	  XPUSHs(sv_2mortal(newSVpv(path, 0)));
	} else {
	  XPUSHs((SV *)&PL_sv_undef);
	}
	XSRETURN(1);
#line 2339 "TokyoCabinet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_TokyoCabinet_bdb_rnum); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdb_rnum)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "bdb");
    {
	void *	bdb = INT2PTR(void *,SvIV(ST(0)))
;
	double	RETVAL;
	dXSTARG;
#line 1230 "TokyoCabinet.xs"
	RETVAL = tcbdbrnum(bdb);
#line 2359 "TokyoCabinet.c"
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_bdb_fsiz); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdb_fsiz)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "bdb");
    {
	void *	bdb = INT2PTR(void *,SvIV(ST(0)))
;
	double	RETVAL;
	dXSTARG;
#line 1239 "TokyoCabinet.xs"
	RETVAL = tcbdbfsiz(bdb);
#line 2379 "TokyoCabinet.c"
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_bdbcur_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdbcur_new)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "bdb");
    {
	void *	bdb = INT2PTR(void *,SvIV(ST(0)))
;
	void *	RETVAL;
	dXSTARG;
#line 1248 "TokyoCabinet.xs"
	RETVAL = tcbdbcurnew(bdb);
#line 2399 "TokyoCabinet.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_bdbcur_del); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdbcur_del)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cur");
    {
	void *	cur = INT2PTR(void *,SvIV(ST(0)))
;
#line 1257 "TokyoCabinet.xs"
	tcbdbcurdel(cur);
#line 2417 "TokyoCabinet.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_TokyoCabinet_bdbcur_first); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdbcur_first)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cur");
    {
	void *	cur = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 1264 "TokyoCabinet.xs"
	RETVAL = tcbdbcurfirst(cur);
#line 2436 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_bdbcur_last); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdbcur_last)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cur");
    {
	void *	cur = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 1273 "TokyoCabinet.xs"
	RETVAL = tcbdbcurlast(cur);
#line 2456 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_bdbcur_jump); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdbcur_jump)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "cur, key");
    {
	void *	cur = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	key = ST(1)
;
#line 1283 "TokyoCabinet.xs"
	const char *kbuf;
	STRLEN ksiz;
#line 2477 "TokyoCabinet.c"
	int	RETVAL;
	dXSTARG;
#line 1286 "TokyoCabinet.xs"
	kbuf = SvPV(key, ksiz);
	RETVAL = tcbdbcurjump(cur, kbuf, (int)ksiz);
#line 2483 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_bdbcur_prev); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdbcur_prev)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cur");
    {
	void *	cur = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 1296 "TokyoCabinet.xs"
	RETVAL = tcbdbcurprev(cur);
#line 2503 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_bdbcur_next); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdbcur_next)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cur");
    {
	void *	cur = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 1305 "TokyoCabinet.xs"
	RETVAL = tcbdbcurnext(cur);
#line 2523 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_bdbcur_put); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdbcur_put)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "cur, val, cpmode");
    {
	void *	cur = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	val = ST(1)
;
	int	cpmode = (int)SvIV(ST(2))
;
#line 1316 "TokyoCabinet.xs"
	const char *vbuf;
	STRLEN vsiz;
#line 2546 "TokyoCabinet.c"
	int	RETVAL;
	dXSTARG;
#line 1319 "TokyoCabinet.xs"
	vbuf = SvPV(val, vsiz);
	RETVAL = tcbdbcurput(cur, vbuf, (int)vsiz, cpmode);
#line 2552 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_bdbcur_out); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdbcur_out)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cur");
    {
	void *	cur = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 1329 "TokyoCabinet.xs"
	RETVAL = tcbdbcurout(cur);
#line 2572 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_bdbcur_key); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdbcur_key)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cur");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	cur = INT2PTR(void *,SvIV(ST(0)))
;
#line 1338 "TokyoCabinet.xs"
	char *kbuf;
	int ksiz;
#line 2593 "TokyoCabinet.c"
#line 1341 "TokyoCabinet.xs"
	kbuf = tcbdbcurkey(cur, &ksiz);
	if(kbuf){
	  XPUSHs(sv_2mortal(newSVpvn(kbuf, ksiz)));
	  tcfree(kbuf);
	} else {
	  XPUSHs((SV *)&PL_sv_undef);
	}
	XSRETURN(1);
#line 2603 "TokyoCabinet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_TokyoCabinet_bdbcur_val); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_bdbcur_val)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cur");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	cur = INT2PTR(void *,SvIV(ST(0)))
;
#line 1355 "TokyoCabinet.xs"
	char *vbuf;
	int vsiz;
#line 2624 "TokyoCabinet.c"
#line 1358 "TokyoCabinet.xs"
	vbuf = tcbdbcurval(cur, &vsiz);
	if(vbuf){
	  XPUSHs(sv_2mortal(newSVpvn(vbuf, vsiz)));
	  tcfree(vbuf);
	} else {
	  XPUSHs((SV *)&PL_sv_undef);
	}
	XSRETURN(1);
#line 2634 "TokyoCabinet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_TokyoCabinet_fdb_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_fdb_new)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 1377 "TokyoCabinet.xs"
	TCFDB *fdb;
#line 2650 "TokyoCabinet.c"
	void *	RETVAL;
	dXSTARG;
#line 1379 "TokyoCabinet.xs"
	fdb = tcfdbnew();
	tcfdbsetmutex(fdb);
	RETVAL = fdb;
#line 2657 "TokyoCabinet.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_fdb_del); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_fdb_del)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fdb");
    {
	void *	fdb = INT2PTR(void *,SvIV(ST(0)))
;
#line 1390 "TokyoCabinet.xs"
	tcfdbdel(fdb);
#line 2675 "TokyoCabinet.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_TokyoCabinet_fdb_errmsg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_fdb_errmsg)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ecode");
    {
	int	ecode = (int)SvIV(ST(0))
;
	const char *	RETVAL;
	dXSTARG;
#line 1397 "TokyoCabinet.xs"
	RETVAL = tcfdberrmsg(ecode);
#line 2694 "TokyoCabinet.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_fdb_ecode); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_fdb_ecode)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fdb");
    {
	void *	fdb = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 1406 "TokyoCabinet.xs"
	RETVAL = tcfdbecode(fdb);
#line 2714 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_fdb_tune); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_fdb_tune)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "fdb, width, limsiz");
    {
	void *	fdb = INT2PTR(void *,SvIV(ST(0)))
;
	int	width = (int)SvIV(ST(1))
;
	double	limsiz = (double)SvNV(ST(2))
;
	int	RETVAL;
	dXSTARG;
#line 1417 "TokyoCabinet.xs"
	RETVAL = tcfdbtune(fdb, width, limsiz);
#line 2738 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_fdb_open); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_fdb_open)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "fdb, path, omode");
    {
	void *	fdb = INT2PTR(void *,SvIV(ST(0)))
;
	char *	path = (char *)SvPV_nolen(ST(1))
;
	int	omode = (int)SvIV(ST(2))
;
	int	RETVAL;
	dXSTARG;
#line 1428 "TokyoCabinet.xs"
	RETVAL = tcfdbopen(fdb, path, omode);
#line 2762 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_fdb_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_fdb_close)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fdb");
    {
	void *	fdb = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 1437 "TokyoCabinet.xs"
	RETVAL = tcfdbclose(fdb);
#line 2782 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_fdb_put); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_fdb_put)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "fdb, key, val");
    {
	void *	fdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	key = ST(1)
;
	SV *	val = ST(2)
;
#line 1448 "TokyoCabinet.xs"
	const char *kbuf, *vbuf;
	STRLEN ksiz, vsiz;
#line 2805 "TokyoCabinet.c"
	int	RETVAL;
	dXSTARG;
#line 1451 "TokyoCabinet.xs"
	kbuf = SvPV(key, ksiz);
	vbuf = SvPV(val, vsiz);
	RETVAL = tcfdbput2(fdb, kbuf, (int)ksiz, vbuf, (int)vsiz);
#line 2812 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_fdb_putkeep); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_fdb_putkeep)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "fdb, key, val");
    {
	void *	fdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	key = ST(1)
;
	SV *	val = ST(2)
;
#line 1464 "TokyoCabinet.xs"
	const char *kbuf, *vbuf;
	STRLEN ksiz, vsiz;
#line 2835 "TokyoCabinet.c"
	int	RETVAL;
	dXSTARG;
#line 1467 "TokyoCabinet.xs"
	kbuf = SvPV(key, ksiz);
	vbuf = SvPV(val, vsiz);
	RETVAL = tcfdbputkeep2(fdb, kbuf, (int)ksiz, vbuf, (int)vsiz);
#line 2842 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_fdb_putcat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_fdb_putcat)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "fdb, key, val");
    {
	void *	fdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	key = ST(1)
;
	SV *	val = ST(2)
;
#line 1480 "TokyoCabinet.xs"
	const char *kbuf, *vbuf;
	STRLEN ksiz, vsiz;
#line 2865 "TokyoCabinet.c"
	int	RETVAL;
	dXSTARG;
#line 1483 "TokyoCabinet.xs"
	kbuf = SvPV(key, ksiz);
	vbuf = SvPV(val, vsiz);
	RETVAL = tcfdbputcat2(fdb, kbuf, (int)ksiz, vbuf, (int)vsiz);
#line 2872 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_fdb_out); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_fdb_out)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "fdb, key");
    {
	void *	fdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	key = ST(1)
;
#line 1495 "TokyoCabinet.xs"
	const char *kbuf;
	STRLEN ksiz;
#line 2893 "TokyoCabinet.c"
	int	RETVAL;
	dXSTARG;
#line 1498 "TokyoCabinet.xs"
	kbuf = SvPV(key, ksiz);
	RETVAL = tcfdbout2(fdb, kbuf, (int)ksiz);
#line 2899 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_fdb_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_fdb_get)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "fdb, key");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	fdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	key = ST(1)
;
#line 1509 "TokyoCabinet.xs"
	const char *kbuf;
	STRLEN ksiz;
	char *vbuf;
	int vsiz;
#line 2924 "TokyoCabinet.c"
#line 1514 "TokyoCabinet.xs"
	kbuf = SvPV(key, ksiz);
	vbuf = tcfdbget2(fdb, kbuf, (int)ksiz, &vsiz);
	if(vbuf){
	  XPUSHs(sv_2mortal(newSVpvn(vbuf, vsiz)));
	  tcfree(vbuf);
	} else {
	  XPUSHs((SV *)&PL_sv_undef);
	}
	XSRETURN(1);
#line 2935 "TokyoCabinet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_TokyoCabinet_fdb_vsiz); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_fdb_vsiz)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "fdb, key");
    {
	void *	fdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	key = ST(1)
;
#line 1530 "TokyoCabinet.xs"
	const char *kbuf;
	STRLEN ksiz;
#line 2956 "TokyoCabinet.c"
	int	RETVAL;
	dXSTARG;
#line 1533 "TokyoCabinet.xs"
	kbuf = SvPV(key, ksiz);
	RETVAL = tcfdbvsiz2(fdb, kbuf, (int)ksiz);
#line 2962 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_fdb_iterinit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_fdb_iterinit)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fdb");
    {
	void *	fdb = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 1543 "TokyoCabinet.xs"
	RETVAL = tcfdbiterinit(fdb);
#line 2982 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_fdb_iternext); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_fdb_iternext)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fdb");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	fdb = INT2PTR(void *,SvIV(ST(0)))
;
#line 1552 "TokyoCabinet.xs"
	char *vbuf;
	int vsiz;
#line 3003 "TokyoCabinet.c"
#line 1555 "TokyoCabinet.xs"
	vbuf = tcfdbiternext2(fdb, &vsiz);
	if(vbuf){
	  XPUSHs(sv_2mortal(newSVpvn(vbuf, vsiz)));
	  tcfree(vbuf);
	} else {
	  XPUSHs((SV *)&PL_sv_undef);
	}
	XSRETURN(1);
#line 3013 "TokyoCabinet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_TokyoCabinet_fdb_range); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_fdb_range)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "fdb, interval, max");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	fdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	interval = ST(1)
;
	int	max = (int)SvIV(ST(2))
;
#line 1571 "TokyoCabinet.xs"
	AV *av;
	STRLEN isiz;
	TCLIST *keys;
	const char *ibuf, *kbuf;
	int i, ksiz;
#line 3041 "TokyoCabinet.c"
#line 1577 "TokyoCabinet.xs"
	ibuf = SvPV(interval, isiz);
	keys = tcfdbrange4(fdb, ibuf, (int)isiz, max);
	av = newAV();
	for(i = 0; i < tclistnum(keys); i++){
	  kbuf = tclistval(keys, i, &ksiz);
	  av_push(av, newSVpvn(kbuf, ksiz));
	}
	tclistdel(keys);
	XPUSHs(sv_2mortal(newRV_noinc((SV *)av)));
	XSRETURN(1);
#line 3053 "TokyoCabinet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_TokyoCabinet_fdb_addint); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_fdb_addint)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "fdb, key, num");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	fdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	key = ST(1)
;
	int	num = (int)SvIV(ST(2))
;
#line 1595 "TokyoCabinet.xs"
	const char *kbuf;
	STRLEN ksiz;
#line 3078 "TokyoCabinet.c"
#line 1598 "TokyoCabinet.xs"
	kbuf = SvPV(key, ksiz);
	num = tcfdbaddint(fdb, tcfdbkeytoid(kbuf, (int)ksiz), num);
	if(num == INT_MIN){
	  XPUSHs((SV *)&PL_sv_undef);
	} else {
	  XPUSHs(sv_2mortal(newSViv(num)));
	}
	XSRETURN(1);
#line 3088 "TokyoCabinet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_TokyoCabinet_fdb_adddouble); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_fdb_adddouble)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "fdb, key, num");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	fdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	key = ST(1)
;
	double	num = (double)SvNV(ST(2))
;
#line 1614 "TokyoCabinet.xs"
	const char *kbuf;
	STRLEN ksiz;
#line 3113 "TokyoCabinet.c"
#line 1617 "TokyoCabinet.xs"
	kbuf = SvPV(key, ksiz);
	num = tcfdbadddouble(fdb, tcfdbkeytoid(kbuf, (int)ksiz), num);
	if(isnan(num)){
	  XPUSHs((SV *)&PL_sv_undef);
	} else {
	  XPUSHs(sv_2mortal(newSVnv(num)));
	}
	XSRETURN(1);
#line 3123 "TokyoCabinet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_TokyoCabinet_fdb_sync); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_fdb_sync)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fdb");
    {
	void *	fdb = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 1631 "TokyoCabinet.xs"
	RETVAL = tcfdbsync(fdb);
#line 3143 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_fdb_optimize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_fdb_optimize)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "fdb, width, limsiz");
    {
	void *	fdb = INT2PTR(void *,SvIV(ST(0)))
;
	int	width = (int)SvIV(ST(1))
;
	double	limsiz = (double)SvNV(ST(2))
;
	int	RETVAL;
	dXSTARG;
#line 1642 "TokyoCabinet.xs"
	RETVAL = tcfdboptimize(fdb, width, limsiz);
#line 3167 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_fdb_vanish); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_fdb_vanish)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fdb");
    {
	void *	fdb = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 1651 "TokyoCabinet.xs"
	RETVAL = tcfdbvanish(fdb);
#line 3187 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_fdb_copy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_fdb_copy)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "fdb, path");
    {
	void *	fdb = INT2PTR(void *,SvIV(ST(0)))
;
	char *	path = (char *)SvPV_nolen(ST(1))
;
	int	RETVAL;
	dXSTARG;
#line 1661 "TokyoCabinet.xs"
	RETVAL = tcfdbcopy(fdb, path);
#line 3209 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_fdb_tranbegin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_fdb_tranbegin)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fdb");
    {
	void *	fdb = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 1670 "TokyoCabinet.xs"
	RETVAL = tcfdbtranbegin(fdb);
#line 3229 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_fdb_trancommit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_fdb_trancommit)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fdb");
    {
	void *	fdb = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 1679 "TokyoCabinet.xs"
	RETVAL = tcfdbtrancommit(fdb);
#line 3249 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_fdb_tranabort); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_fdb_tranabort)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fdb");
    {
	void *	fdb = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 1688 "TokyoCabinet.xs"
	RETVAL = tcfdbtranabort(fdb);
#line 3269 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_fdb_path); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_fdb_path)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fdb");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	fdb = INT2PTR(void *,SvIV(ST(0)))
;
#line 1697 "TokyoCabinet.xs"
	const char *path;
#line 3289 "TokyoCabinet.c"
#line 1699 "TokyoCabinet.xs"
	path = tcfdbpath(fdb);
	if(path){
	  XPUSHs(sv_2mortal(newSVpv(path, 0)));
	} else {
	  XPUSHs((SV *)&PL_sv_undef);
	}
	XSRETURN(1);
#line 3298 "TokyoCabinet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_TokyoCabinet_fdb_rnum); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_fdb_rnum)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fdb");
    {
	void *	fdb = INT2PTR(void *,SvIV(ST(0)))
;
	double	RETVAL;
	dXSTARG;
#line 1712 "TokyoCabinet.xs"
	RETVAL = tcfdbrnum(fdb);
#line 3318 "TokyoCabinet.c"
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_fdb_fsiz); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_fdb_fsiz)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fdb");
    {
	void *	fdb = INT2PTR(void *,SvIV(ST(0)))
;
	double	RETVAL;
	dXSTARG;
#line 1721 "TokyoCabinet.xs"
	RETVAL = tcfdbfsiz(fdb);
#line 3338 "TokyoCabinet.c"
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_tdb_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdb_new)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 1735 "TokyoCabinet.xs"
	TCTDB *tdb;
#line 3354 "TokyoCabinet.c"
	void *	RETVAL;
	dXSTARG;
#line 1737 "TokyoCabinet.xs"
	tdb = tctdbnew();
	tctdbsetmutex(tdb);
	RETVAL = tdb;
#line 3361 "TokyoCabinet.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_tdb_del); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdb_del)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "tdb");
    {
	void *	tdb = INT2PTR(void *,SvIV(ST(0)))
;
#line 1748 "TokyoCabinet.xs"
	tctdbdel(tdb);
#line 3379 "TokyoCabinet.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_TokyoCabinet_tdb_errmsg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdb_errmsg)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ecode");
    {
	int	ecode = (int)SvIV(ST(0))
;
	const char *	RETVAL;
	dXSTARG;
#line 1755 "TokyoCabinet.xs"
	RETVAL = tctdberrmsg(ecode);
#line 3398 "TokyoCabinet.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_tdb_ecode); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdb_ecode)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "tdb");
    {
	void *	tdb = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 1764 "TokyoCabinet.xs"
	RETVAL = tctdbecode(tdb);
#line 3418 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_tdb_tune); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdb_tune)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "tdb, bnum, apow, fpow, opts");
    {
	void *	tdb = INT2PTR(void *,SvIV(ST(0)))
;
	double	bnum = (double)SvNV(ST(1))
;
	int	apow = (int)SvIV(ST(2))
;
	int	fpow = (int)SvIV(ST(3))
;
	int	opts = (int)SvIV(ST(4))
;
	int	RETVAL;
	dXSTARG;
#line 1777 "TokyoCabinet.xs"
	RETVAL = tctdbtune(tdb, bnum, apow, fpow, opts);
#line 3446 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_tdb_setcache); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdb_setcache)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "tdb, rcnum, lcnum, ncnum");
    {
	void *	tdb = INT2PTR(void *,SvIV(ST(0)))
;
	int	rcnum = (int)SvIV(ST(1))
;
	int	lcnum = (int)SvIV(ST(2))
;
	int	ncnum = (int)SvIV(ST(3))
;
	int	RETVAL;
	dXSTARG;
#line 1789 "TokyoCabinet.xs"
	RETVAL = tctdbsetcache(tdb, rcnum, lcnum, ncnum);
#line 3472 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_tdb_setxmsiz); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdb_setxmsiz)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "tdb, xmsiz");
    {
	void *	tdb = INT2PTR(void *,SvIV(ST(0)))
;
	double	xmsiz = (double)SvNV(ST(1))
;
	int	RETVAL;
	dXSTARG;
#line 1799 "TokyoCabinet.xs"
	RETVAL = tctdbsetxmsiz(tdb, xmsiz);
#line 3494 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_tdb_setdfunit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdb_setdfunit)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "tdb, dfunit");
    {
	void *	tdb = INT2PTR(void *,SvIV(ST(0)))
;
	int	dfunit = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;
#line 1809 "TokyoCabinet.xs"
	RETVAL = tctdbsetdfunit(tdb, dfunit);
#line 3516 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_tdb_open); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdb_open)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "tdb, path, omode");
    {
	void *	tdb = INT2PTR(void *,SvIV(ST(0)))
;
	char *	path = (char *)SvPV_nolen(ST(1))
;
	int	omode = (int)SvIV(ST(2))
;
	int	RETVAL;
	dXSTARG;
#line 1820 "TokyoCabinet.xs"
	RETVAL = tctdbopen(tdb, path, omode);
#line 3540 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_tdb_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdb_close)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "tdb");
    {
	void *	tdb = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 1829 "TokyoCabinet.xs"
	RETVAL = tctdbclose(tdb);
#line 3560 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_tdb_put); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdb_put)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "tdb, pkey, cols");
    {
	void *	tdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	pkey = ST(1)
;
	HV *	cols;
#line 1840 "TokyoCabinet.xs"
	SV *sv;
	const char *pkbuf;
	char *kbuf, *vbuf;
	STRLEN pksiz, vsiz;
	I32 ksiz;
	TCMAP *tcols;
#line 3586 "TokyoCabinet.c"
	int	RETVAL;
	dXSTARG;

	STMT_START {
		SV* const xsub_tmp_sv = ST(2);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    cols = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"TokyoCabinet::tdb_put",
				"cols");
		}
	} STMT_END
;
#line 1847 "TokyoCabinet.xs"
	pkbuf = SvPV(pkey, pksiz);
	tcols = tcmapnew2(31);
	hv_iterinit(cols);
	while((sv = hv_iternextsv(cols, &kbuf, &ksiz)) != NULL){
	  vbuf = SvPV(sv, vsiz);
	  tcmapput(tcols, kbuf, ksiz, vbuf, vsiz);
	}
	RETVAL = tctdbput(tdb, pkbuf, pksiz, tcols);
	tcmapdel(tcols);
#line 3613 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_tdb_putkeep); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdb_putkeep)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "tdb, pkey, cols");
    {
	void *	tdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	pkey = ST(1)
;
	HV *	cols;
#line 1866 "TokyoCabinet.xs"
	SV *sv;
	const char *pkbuf;
	char *kbuf, *vbuf;
	STRLEN pksiz, vsiz;
	I32 ksiz;
	TCMAP *tcols;
#line 3639 "TokyoCabinet.c"
	int	RETVAL;
	dXSTARG;

	STMT_START {
		SV* const xsub_tmp_sv = ST(2);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    cols = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"TokyoCabinet::tdb_putkeep",
				"cols");
		}
	} STMT_END
;
#line 1873 "TokyoCabinet.xs"
	pkbuf = SvPV(pkey, pksiz);
	tcols = tcmapnew2(31);
	hv_iterinit(cols);
	while((sv = hv_iternextsv(cols, &kbuf, &ksiz)) != NULL){
	  vbuf = SvPV(sv, vsiz);
	  tcmapput(tcols, kbuf, ksiz, vbuf, vsiz);
	}
	RETVAL = tctdbputkeep(tdb, pkbuf, pksiz, tcols);
	tcmapdel(tcols);
#line 3666 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_tdb_putcat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdb_putcat)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "tdb, pkey, cols");
    {
	void *	tdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	pkey = ST(1)
;
	HV *	cols;
#line 1892 "TokyoCabinet.xs"
	SV *sv;
	const char *pkbuf;
	char *kbuf, *vbuf;
	STRLEN pksiz, vsiz;
	I32 ksiz;
	TCMAP *tcols;
#line 3692 "TokyoCabinet.c"
	int	RETVAL;
	dXSTARG;

	STMT_START {
		SV* const xsub_tmp_sv = ST(2);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    cols = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"TokyoCabinet::tdb_putcat",
				"cols");
		}
	} STMT_END
;
#line 1899 "TokyoCabinet.xs"
	pkbuf = SvPV(pkey, pksiz);
	tcols = tcmapnew2(31);
	hv_iterinit(cols);
	while((sv = hv_iternextsv(cols, &kbuf, &ksiz)) != NULL){
	  vbuf = SvPV(sv, vsiz);
	  tcmapput(tcols, kbuf, ksiz, vbuf, vsiz);
	}
	RETVAL = tctdbputcat(tdb, pkbuf, pksiz, tcols);
	tcmapdel(tcols);
#line 3719 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_tdb_out); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdb_out)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "tdb, pkey");
    {
	void *	tdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	pkey = ST(1)
;
#line 1917 "TokyoCabinet.xs"
	const char *pkbuf;
	STRLEN pksiz;
#line 3740 "TokyoCabinet.c"
	int	RETVAL;
	dXSTARG;
#line 1920 "TokyoCabinet.xs"
	pkbuf = SvPV(pkey, pksiz);
	RETVAL = tctdbout(tdb, pkbuf, (int)pksiz);
#line 3746 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_tdb_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdb_get)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "tdb, pkey");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	tdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	pkey = ST(1)
;
#line 1931 "TokyoCabinet.xs"
	const char *pkbuf, *kbuf, *vbuf;
	STRLEN pksiz;
	int ksiz, vsiz;
	TCMAP *tcols;
	HV *cols;
#line 3772 "TokyoCabinet.c"
#line 1937 "TokyoCabinet.xs"
	pkbuf = SvPV(pkey, pksiz);
	tcols = tctdbget(tdb, pkbuf, (int)pksiz);
	if(tcols){
	  cols = newHV();
	  tcmapiterinit(tcols);
	  while((kbuf = tcmapiternext(tcols, &ksiz)) != NULL){
	    vbuf = tcmapiterval(kbuf, &vsiz);
	    hv_store(cols, kbuf, ksiz, newSVpvn(vbuf, vsiz), 0);
	  }
	  tcmapdel(tcols);
	  XPUSHs(sv_2mortal(newRV_noinc((SV *)cols)));
	} else {
	  XPUSHs((SV *)&PL_sv_undef);
	}
	XSRETURN(1);
#line 3789 "TokyoCabinet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_TokyoCabinet_tdb_vsiz); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdb_vsiz)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "tdb, pkey");
    {
	void *	tdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	pkey = ST(1)
;
#line 1959 "TokyoCabinet.xs"
	const char *pkbuf;
	STRLEN pksiz;
#line 3810 "TokyoCabinet.c"
	int	RETVAL;
	dXSTARG;
#line 1962 "TokyoCabinet.xs"
	pkbuf = SvPV(pkey, pksiz);
	RETVAL = tctdbvsiz(tdb, pkbuf, (int)pksiz);
#line 3816 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_tdb_iterinit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdb_iterinit)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "tdb");
    {
	void *	tdb = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 1972 "TokyoCabinet.xs"
	RETVAL = tctdbiterinit(tdb);
#line 3836 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_tdb_iternext); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdb_iternext)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "tdb");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	tdb = INT2PTR(void *,SvIV(ST(0)))
;
#line 1981 "TokyoCabinet.xs"
	char *vbuf;
	int vsiz;
#line 3857 "TokyoCabinet.c"
#line 1984 "TokyoCabinet.xs"
	vbuf = tctdbiternext(tdb, &vsiz);
	if(vbuf){
	  XPUSHs(sv_2mortal(newSVpvn(vbuf, vsiz)));
	  tcfree(vbuf);
	} else {
	  XPUSHs((SV *)&PL_sv_undef);
	}
	XSRETURN(1);
#line 3867 "TokyoCabinet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_TokyoCabinet_tdb_fwmkeys); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdb_fwmkeys)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "tdb, prefix, max");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	tdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	prefix = ST(1)
;
	int	max = (int)SvIV(ST(2))
;
#line 2000 "TokyoCabinet.xs"
	AV *av;
	STRLEN psiz;
	TCLIST *pkeys;
	const char *pbuf, *pkbuf;
	int i, pksiz;
#line 3895 "TokyoCabinet.c"
#line 2006 "TokyoCabinet.xs"
	pbuf = SvPV(prefix, psiz);
	pkeys = tctdbfwmkeys(tdb, pbuf, (int)psiz, max);
	av = newAV();
	for(i = 0; i < tclistnum(pkeys); i++){
	  pkbuf = tclistval(pkeys, i, &pksiz);
	  av_push(av, newSVpvn(pkbuf, pksiz));
	}
	tclistdel(pkeys);
	XPUSHs(sv_2mortal(newRV_noinc((SV *)av)));
	XSRETURN(1);
#line 3907 "TokyoCabinet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_TokyoCabinet_tdb_addint); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdb_addint)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "tdb, pkey, num");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	tdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	pkey = ST(1)
;
	int	num = (int)SvIV(ST(2))
;
#line 2024 "TokyoCabinet.xs"
	const char *pkbuf;
	STRLEN pksiz;
#line 3932 "TokyoCabinet.c"
#line 2027 "TokyoCabinet.xs"
	pkbuf = SvPV(pkey, pksiz);
	num = tctdbaddint(tdb, pkbuf, (int)pksiz, num);
	if(num == INT_MIN){
	  XPUSHs((SV *)&PL_sv_undef);
	} else {
	  XPUSHs(sv_2mortal(newSViv(num)));
	}
	XSRETURN(1);
#line 3942 "TokyoCabinet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_TokyoCabinet_tdb_adddouble); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdb_adddouble)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "tdb, pkey, num");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	tdb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	pkey = ST(1)
;
	double	num = (double)SvNV(ST(2))
;
#line 2043 "TokyoCabinet.xs"
	const char *pkbuf;
	STRLEN pksiz;
#line 3967 "TokyoCabinet.c"
#line 2046 "TokyoCabinet.xs"
	pkbuf = SvPV(pkey, pksiz);
	num = tctdbadddouble(tdb, pkbuf, (int)pksiz, num);
	if(isnan(num)){
	  XPUSHs((SV *)&PL_sv_undef);
	} else {
	  XPUSHs(sv_2mortal(newSVnv(num)));
	}
	XSRETURN(1);
#line 3977 "TokyoCabinet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_TokyoCabinet_tdb_sync); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdb_sync)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "tdb");
    {
	void *	tdb = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 2060 "TokyoCabinet.xs"
	RETVAL = tctdbsync(tdb);
#line 3997 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_tdb_optimize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdb_optimize)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "tdb, bnum, apow, fpow, opts");
    {
	void *	tdb = INT2PTR(void *,SvIV(ST(0)))
;
	double	bnum = (double)SvNV(ST(1))
;
	int	apow = (int)SvIV(ST(2))
;
	int	fpow = (int)SvIV(ST(3))
;
	int	opts = (int)SvIV(ST(4))
;
	int	RETVAL;
	dXSTARG;
#line 2073 "TokyoCabinet.xs"
	RETVAL = tctdboptimize(tdb, bnum, apow, fpow, opts);
#line 4025 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_tdb_vanish); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdb_vanish)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "tdb");
    {
	void *	tdb = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 2082 "TokyoCabinet.xs"
	RETVAL = tctdbvanish(tdb);
#line 4045 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_tdb_copy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdb_copy)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "tdb, path");
    {
	void *	tdb = INT2PTR(void *,SvIV(ST(0)))
;
	char *	path = (char *)SvPV_nolen(ST(1))
;
	int	RETVAL;
	dXSTARG;
#line 2092 "TokyoCabinet.xs"
	RETVAL = tctdbcopy(tdb, path);
#line 4067 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_tdb_tranbegin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdb_tranbegin)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "tdb");
    {
	void *	tdb = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 2101 "TokyoCabinet.xs"
	RETVAL = tctdbtranbegin(tdb);
#line 4087 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_tdb_trancommit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdb_trancommit)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "tdb");
    {
	void *	tdb = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 2110 "TokyoCabinet.xs"
	RETVAL = tctdbtrancommit(tdb);
#line 4107 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_tdb_tranabort); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdb_tranabort)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "tdb");
    {
	void *	tdb = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 2119 "TokyoCabinet.xs"
	RETVAL = tctdbtranabort(tdb);
#line 4127 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_tdb_path); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdb_path)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "tdb");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	tdb = INT2PTR(void *,SvIV(ST(0)))
;
#line 2128 "TokyoCabinet.xs"
	const char *path;
#line 4147 "TokyoCabinet.c"
#line 2130 "TokyoCabinet.xs"
	path = tctdbpath(tdb);
	if(path){
	  XPUSHs(sv_2mortal(newSVpv(path, 0)));
	} else {
	  XPUSHs((SV *)&PL_sv_undef);
	}
	XSRETURN(1);
#line 4156 "TokyoCabinet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_TokyoCabinet_tdb_rnum); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdb_rnum)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "tdb");
    {
	void *	tdb = INT2PTR(void *,SvIV(ST(0)))
;
	double	RETVAL;
	dXSTARG;
#line 2143 "TokyoCabinet.xs"
	RETVAL = tctdbrnum(tdb);
#line 4176 "TokyoCabinet.c"
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_tdb_fsiz); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdb_fsiz)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "tdb");
    {
	void *	tdb = INT2PTR(void *,SvIV(ST(0)))
;
	double	RETVAL;
	dXSTARG;
#line 2152 "TokyoCabinet.xs"
	RETVAL = tctdbfsiz(tdb);
#line 4196 "TokyoCabinet.c"
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_tdb_setindex); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdb_setindex)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "tdb, name, type");
    {
	void *	tdb = INT2PTR(void *,SvIV(ST(0)))
;
	char *	name = (char *)SvPV_nolen(ST(1))
;
	int	type = (int)SvIV(ST(2))
;
	int	RETVAL;
	dXSTARG;
#line 2163 "TokyoCabinet.xs"
	RETVAL = tctdbsetindex(tdb, name, type);
#line 4220 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_tdb_genuid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdb_genuid)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "tdb");
    {
	void *	tdb = INT2PTR(void *,SvIV(ST(0)))
;
	double	RETVAL;
	dXSTARG;
#line 2172 "TokyoCabinet.xs"
	RETVAL = tctdbgenuid(tdb);
#line 4240 "TokyoCabinet.c"
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_tdbqry_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdbqry_new)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "tdb");
    {
	void *	tdb = INT2PTR(void *,SvIV(ST(0)))
;
	void *	RETVAL;
	dXSTARG;
#line 2181 "TokyoCabinet.xs"
	RETVAL = tctdbqrynew(tdb);
#line 4260 "TokyoCabinet.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_tdbqry_del); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdbqry_del)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "qry");
    {
	void *	qry = INT2PTR(void *,SvIV(ST(0)))
;
#line 2190 "TokyoCabinet.xs"
	tctdbqrydel(qry);
#line 4278 "TokyoCabinet.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_TokyoCabinet_tdbqry_addcond); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdbqry_addcond)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "qry, name, op, expr");
    {
	void *	qry = INT2PTR(void *,SvIV(ST(0)))
;
	char *	name = (char *)SvPV_nolen(ST(1))
;
	int	op = (int)SvIV(ST(2))
;
	char *	expr = (char *)SvPV_nolen(ST(3))
;
#line 2200 "TokyoCabinet.xs"
	tctdbqryaddcond(qry, name, op, expr);
#line 4301 "TokyoCabinet.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_TokyoCabinet_tdbqry_setorder); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdbqry_setorder)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "qry, name, type");
    {
	void *	qry = INT2PTR(void *,SvIV(ST(0)))
;
	char *	name = (char *)SvPV_nolen(ST(1))
;
	int	type = (int)SvIV(ST(2))
;
#line 2209 "TokyoCabinet.xs"
	tctdbqrysetorder(qry, name, type);
#line 4322 "TokyoCabinet.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_TokyoCabinet_tdbqry_setlimit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdbqry_setlimit)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "qry, max, skip");
    {
	void *	qry = INT2PTR(void *,SvIV(ST(0)))
;
	int	max = (int)SvIV(ST(1))
;
	int	skip = (int)SvIV(ST(2))
;
#line 2218 "TokyoCabinet.xs"
	tctdbqrysetlimit(qry, max, skip);
#line 4343 "TokyoCabinet.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_TokyoCabinet_tdbqry_search); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdbqry_search)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "qry");
    {
	void *	qry = INT2PTR(void *,SvIV(ST(0)))
;
#line 2225 "TokyoCabinet.xs"
	AV *av;
	TCLIST *pkeys;
	const char *pkbuf;
	int i, pksiz;
#line 4363 "TokyoCabinet.c"
	AV *	RETVAL;
#line 2230 "TokyoCabinet.xs"
	pkeys = tctdbqrysearch(qry);
	av = newAV();
	for(i = 0; i < tclistnum(pkeys); i++){
	  pkbuf = tclistval(pkeys, i, &pksiz);
	  av_push(av, newSVpvn(pkbuf, pksiz));
	}
	tclistdel(pkeys);
	RETVAL = (AV *)sv_2mortal((SV *)av);
#line 4374 "TokyoCabinet.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_tdbqry_searchout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdbqry_searchout)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "qry");
    {
	void *	qry = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 2246 "TokyoCabinet.xs"
	RETVAL = tctdbqrysearchout(qry);
#line 4399 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_tdbqry_proc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdbqry_proc)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "qry, proc");
    {
	void *	qry = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	proc = ST(1)
;
	int	RETVAL;
	dXSTARG;
#line 2256 "TokyoCabinet.xs"
	RETVAL = tctdbqryproc(qry, (TDBQRYPROC)tdbqry_proc, proc);
#line 4421 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_tdbqry_hint); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdbqry_hint)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "qry");
    {
	void *	qry = INT2PTR(void *,SvIV(ST(0)))
;
#line 2265 "TokyoCabinet.xs"
	const char *hint;
#line 4439 "TokyoCabinet.c"
	char *	RETVAL;
	dXSTARG;
#line 2267 "TokyoCabinet.xs"
	RETVAL = (char *)tctdbqryhint(qry);
#line 4444 "TokyoCabinet.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_tdbqry_metasearch); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdbqry_metasearch)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "qry, others, type");
    {
	void *	qry = INT2PTR(void *,SvIV(ST(0)))
;
	AV *	others;
	int	type = (int)SvIV(ST(2))
;
#line 2278 "TokyoCabinet.xs"
	SV *rqry;
	AV *av;
	TDBQRY **qrys, *tqry;
	TCLIST *pkeys;
	const char *pkbuf;
	int i, num, qnum, pksiz;
#line 4470 "TokyoCabinet.c"
	AV *	RETVAL;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    others = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"TokyoCabinet::tdbqry_metasearch",
				"others");
		}
	} STMT_END
;
#line 2285 "TokyoCabinet.xs"
	num = av_len(others) + 1;
	qrys = tcmalloc(sizeof(*qrys) * (num + 1));
	qnum = 0;
	qrys[qnum++] = qry;
	for(i = 0; i < num; i++){
	  rqry = *av_fetch(others, i, 0);
	  if(sv_isobject(rqry) && sv_isa(rqry, "TokyoCabinet::TDBQRY")){
	    qrys[qnum++] = (TDBQRY *)SvIV(*av_fetch((AV *)SvRV(rqry), 0, 0));
	  }
	}
	pkeys = tctdbmetasearch(qrys, qnum, type);
	tcfree(qrys);
	av = newAV();
	for(i = 0; i < tclistnum(pkeys); i++){
	  pkbuf = tclistval(pkeys, i, &pksiz);
	  av_push(av, newSVpvn(pkbuf, pksiz));
	}
	tclistdel(pkeys);
	RETVAL = (AV *)sv_2mortal((SV *)av);
#line 4506 "TokyoCabinet.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_tdbqry_kwic); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_tdbqry_kwic)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "qry, cols, name, width, opts");
    {
	void *	qry = INT2PTR(void *,SvIV(ST(0)))
;
	HV *	cols;
	char *	name = (char *)SvPV_nolen(ST(2))
;
	int	width = (int)SvIV(ST(3))
;
	int	opts = (int)SvIV(ST(4))
;
#line 2316 "TokyoCabinet.xs"
	SV *sv, **svp;
	AV *av;
	char *kbuf, *vbuf;
	const char *tbuf;
	STRLEN pksiz, vsiz;
	I32 ksiz;
	int i, tsiz;
	TCMAP *tcols;
	TCLIST *texts;
#line 4544 "TokyoCabinet.c"
	AV *	RETVAL;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    cols = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"TokyoCabinet::tdbqry_kwic",
				"cols");
		}
	} STMT_END
;
#line 2326 "TokyoCabinet.xs"
	tcols = tcmapnew2(31);
	if(!strcmp(name, "[[undef]]")){
	  hv_iterinit(cols);
	  while((sv = hv_iternextsv(cols, &kbuf, &ksiz)) != NULL){
	    vbuf = SvPV(sv, vsiz);
	    tcmapput(tcols, kbuf, ksiz, vbuf, vsiz);
	  }
	  name = NULL;
	} else {
	  svp = hv_fetch(cols, name, strlen(name), 0);
	  if(svp){
	    vbuf = SvPV(*svp, vsiz);
	    tcmapput(tcols, name, strlen(name), vbuf, vsiz);
	  }
	}
	texts = tctdbqrykwic(qry, tcols, name, width, opts);
	av = newAV();
	for(i = 0; i < tclistnum(texts); i++){
	  tbuf = tclistval(texts, i, &tsiz);
	  av_push(av, newSVpvn(tbuf, tsiz));
	}
	tclistdel(texts);
	tcmapdel(tcols);
	RETVAL = (AV *)sv_2mortal((SV *)av);
#line 4585 "TokyoCabinet.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_adb_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_adb_new)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 2363 "TokyoCabinet.xs"
	TCADB *adb;
#line 4606 "TokyoCabinet.c"
	void *	RETVAL;
	dXSTARG;
#line 2365 "TokyoCabinet.xs"
	adb = tcadbnew();
	RETVAL = adb;
#line 4612 "TokyoCabinet.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_adb_del); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_adb_del)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "adb");
    {
	void *	adb = INT2PTR(void *,SvIV(ST(0)))
;
#line 2375 "TokyoCabinet.xs"
	tcadbdel(adb);
#line 4630 "TokyoCabinet.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_TokyoCabinet_adb_open); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_adb_open)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "adb, name");
    {
	void *	adb = INT2PTR(void *,SvIV(ST(0)))
;
	char *	name = (char *)SvPV_nolen(ST(1))
;
	int	RETVAL;
	dXSTARG;
#line 2383 "TokyoCabinet.xs"
	RETVAL = tcadbopen(adb, name);
#line 4651 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_adb_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_adb_close)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "adb");
    {
	void *	adb = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 2392 "TokyoCabinet.xs"
	RETVAL = tcadbclose(adb);
#line 4671 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_adb_put); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_adb_put)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "adb, key, val");
    {
	void *	adb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	key = ST(1)
;
	SV *	val = ST(2)
;
#line 2403 "TokyoCabinet.xs"
	const char *kbuf, *vbuf;
	STRLEN ksiz, vsiz;
#line 4694 "TokyoCabinet.c"
	int	RETVAL;
	dXSTARG;
#line 2406 "TokyoCabinet.xs"
	kbuf = SvPV(key, ksiz);
	vbuf = SvPV(val, vsiz);
	RETVAL = tcadbput(adb, kbuf, (int)ksiz, vbuf, (int)vsiz);
#line 4701 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_adb_putkeep); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_adb_putkeep)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "adb, key, val");
    {
	void *	adb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	key = ST(1)
;
	SV *	val = ST(2)
;
#line 2419 "TokyoCabinet.xs"
	const char *kbuf, *vbuf;
	STRLEN ksiz, vsiz;
#line 4724 "TokyoCabinet.c"
	int	RETVAL;
	dXSTARG;
#line 2422 "TokyoCabinet.xs"
	kbuf = SvPV(key, ksiz);
	vbuf = SvPV(val, vsiz);
	RETVAL = tcadbputkeep(adb, kbuf, (int)ksiz, vbuf, (int)vsiz);
#line 4731 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_adb_putcat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_adb_putcat)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "adb, key, val");
    {
	void *	adb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	key = ST(1)
;
	SV *	val = ST(2)
;
#line 2435 "TokyoCabinet.xs"
	const char *kbuf, *vbuf;
	STRLEN ksiz, vsiz;
#line 4754 "TokyoCabinet.c"
	int	RETVAL;
	dXSTARG;
#line 2438 "TokyoCabinet.xs"
	kbuf = SvPV(key, ksiz);
	vbuf = SvPV(val, vsiz);
	RETVAL = tcadbputcat(adb, kbuf, (int)ksiz, vbuf, (int)vsiz);
#line 4761 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_adb_out); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_adb_out)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "adb, key");
    {
	void *	adb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	key = ST(1)
;
#line 2450 "TokyoCabinet.xs"
	const char *kbuf;
	STRLEN ksiz;
#line 4782 "TokyoCabinet.c"
	int	RETVAL;
	dXSTARG;
#line 2453 "TokyoCabinet.xs"
	kbuf = SvPV(key, ksiz);
	RETVAL = tcadbout(adb, kbuf, (int)ksiz);
#line 4788 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_adb_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_adb_get)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "adb, key");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	adb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	key = ST(1)
;
#line 2464 "TokyoCabinet.xs"
	const char *kbuf;
	STRLEN ksiz;
	char *vbuf;
	int vsiz;
#line 4813 "TokyoCabinet.c"
#line 2469 "TokyoCabinet.xs"
	kbuf = SvPV(key, ksiz);
	vbuf = tcadbget(adb, kbuf, (int)ksiz, &vsiz);
	if(vbuf){
	  XPUSHs(sv_2mortal(newSVpvn(vbuf, vsiz)));
	  tcfree(vbuf);
	} else {
	  XPUSHs((SV *)&PL_sv_undef);
	}
	XSRETURN(1);
#line 4824 "TokyoCabinet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_TokyoCabinet_adb_vsiz); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_adb_vsiz)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "adb, key");
    {
	void *	adb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	key = ST(1)
;
#line 2485 "TokyoCabinet.xs"
	const char *kbuf;
	STRLEN ksiz;
#line 4845 "TokyoCabinet.c"
	int	RETVAL;
	dXSTARG;
#line 2488 "TokyoCabinet.xs"
	kbuf = SvPV(key, ksiz);
	RETVAL = tcadbvsiz(adb, kbuf, (int)ksiz);
#line 4851 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_adb_iterinit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_adb_iterinit)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "adb");
    {
	void *	adb = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 2498 "TokyoCabinet.xs"
	RETVAL = tcadbiterinit(adb);
#line 4871 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_adb_iternext); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_adb_iternext)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "adb");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	adb = INT2PTR(void *,SvIV(ST(0)))
;
#line 2507 "TokyoCabinet.xs"
	char *vbuf;
	int vsiz;
#line 4892 "TokyoCabinet.c"
#line 2510 "TokyoCabinet.xs"
	vbuf = tcadbiternext(adb, &vsiz);
	if(vbuf){
	  XPUSHs(sv_2mortal(newSVpvn(vbuf, vsiz)));
	  tcfree(vbuf);
	} else {
	  XPUSHs((SV *)&PL_sv_undef);
	}
	XSRETURN(1);
#line 4902 "TokyoCabinet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_TokyoCabinet_adb_fwmkeys); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_adb_fwmkeys)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "adb, prefix, max");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	adb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	prefix = ST(1)
;
	int	max = (int)SvIV(ST(2))
;
#line 2526 "TokyoCabinet.xs"
	AV *av;
	STRLEN psiz;
	TCLIST *keys;
	const char *pbuf, *kbuf;
	int i, ksiz;
#line 4930 "TokyoCabinet.c"
#line 2532 "TokyoCabinet.xs"
	pbuf = SvPV(prefix, psiz);
	keys = tcadbfwmkeys(adb, pbuf, (int)psiz, max);
	av = newAV();
	for(i = 0; i < tclistnum(keys); i++){
	  kbuf = tclistval(keys, i, &ksiz);
	  av_push(av, newSVpvn(kbuf, ksiz));
	}
	tclistdel(keys);
	XPUSHs(sv_2mortal(newRV_noinc((SV *)av)));
	XSRETURN(1);
#line 4942 "TokyoCabinet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_TokyoCabinet_adb_addint); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_adb_addint)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "adb, key, num");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	adb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	key = ST(1)
;
	int	num = (int)SvIV(ST(2))
;
#line 2550 "TokyoCabinet.xs"
	const char *kbuf;
	STRLEN ksiz;
#line 4967 "TokyoCabinet.c"
#line 2553 "TokyoCabinet.xs"
	kbuf = SvPV(key, ksiz);
	num = tcadbaddint(adb, kbuf, (int)ksiz, num);
	if(num == INT_MIN){
	  XPUSHs((SV *)&PL_sv_undef);
	} else {
	  XPUSHs(sv_2mortal(newSViv(num)));
	}
	XSRETURN(1);
#line 4977 "TokyoCabinet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_TokyoCabinet_adb_adddouble); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_adb_adddouble)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "adb, key, num");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	adb = INT2PTR(void *,SvIV(ST(0)))
;
	SV *	key = ST(1)
;
	double	num = (double)SvNV(ST(2))
;
#line 2569 "TokyoCabinet.xs"
	const char *kbuf;
	STRLEN ksiz;
#line 5002 "TokyoCabinet.c"
#line 2572 "TokyoCabinet.xs"
	kbuf = SvPV(key, ksiz);
	num = tcadbadddouble(adb, kbuf, (int)ksiz, num);
	if(isnan(num)){
	  XPUSHs((SV *)&PL_sv_undef);
	} else {
	  XPUSHs(sv_2mortal(newSVnv(num)));
	}
	XSRETURN(1);
#line 5012 "TokyoCabinet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_TokyoCabinet_adb_sync); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_adb_sync)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "adb");
    {
	void *	adb = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 2586 "TokyoCabinet.xs"
	RETVAL = tcadbsync(adb);
#line 5032 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_adb_optimize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_adb_optimize)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "adb, params");
    {
	void *	adb = INT2PTR(void *,SvIV(ST(0)))
;
	char *	params = (char *)SvPV_nolen(ST(1))
;
	int	RETVAL;
	dXSTARG;
#line 2596 "TokyoCabinet.xs"
	RETVAL = tcadboptimize(adb, params);
#line 5054 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_adb_vanish); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_adb_vanish)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "adb");
    {
	void *	adb = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 2605 "TokyoCabinet.xs"
	RETVAL = tcadbvanish(adb);
#line 5074 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_adb_copy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_adb_copy)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "adb, path");
    {
	void *	adb = INT2PTR(void *,SvIV(ST(0)))
;
	char *	path = (char *)SvPV_nolen(ST(1))
;
	int	RETVAL;
	dXSTARG;
#line 2615 "TokyoCabinet.xs"
	RETVAL = tcadbcopy(adb, path);
#line 5096 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_adb_tranbegin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_adb_tranbegin)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "adb");
    {
	void *	adb = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 2624 "TokyoCabinet.xs"
	RETVAL = tcadbtranbegin(adb);
#line 5116 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_adb_trancommit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_adb_trancommit)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "adb");
    {
	void *	adb = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 2633 "TokyoCabinet.xs"
	RETVAL = tcadbtrancommit(adb);
#line 5136 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_adb_tranabort); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_adb_tranabort)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "adb");
    {
	void *	adb = INT2PTR(void *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 2642 "TokyoCabinet.xs"
	RETVAL = tcadbtranabort(adb);
#line 5156 "TokyoCabinet.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_adb_path); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_adb_path)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "adb");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	adb = INT2PTR(void *,SvIV(ST(0)))
;
#line 2651 "TokyoCabinet.xs"
	const char *path;
#line 5176 "TokyoCabinet.c"
#line 2653 "TokyoCabinet.xs"
	path = tcadbpath(adb);
	if(path){
	  XPUSHs(sv_2mortal(newSVpv(path, 0)));
	} else {
	  XPUSHs((SV *)&PL_sv_undef);
	}
	XSRETURN(1);
#line 5185 "TokyoCabinet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_TokyoCabinet_adb_rnum); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_adb_rnum)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "adb");
    {
	void *	adb = INT2PTR(void *,SvIV(ST(0)))
;
	double	RETVAL;
	dXSTARG;
#line 2666 "TokyoCabinet.xs"
	RETVAL = tcadbrnum(adb);
#line 5205 "TokyoCabinet.c"
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_adb_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_adb_size)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "adb");
    {
	void *	adb = INT2PTR(void *,SvIV(ST(0)))
;
	double	RETVAL;
	dXSTARG;
#line 2675 "TokyoCabinet.xs"
	RETVAL = tcadbsize(adb);
#line 5225 "TokyoCabinet.c"
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_TokyoCabinet_adb_misc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_TokyoCabinet_adb_misc)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "adb, name, args");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	adb = INT2PTR(void *,SvIV(ST(0)))
;
	char *	name = (char *)SvPV_nolen(ST(1))
;
	AV *	args;
#line 2686 "TokyoCabinet.xs"
	SV *arg;
	AV *av;
	TCLIST *targs, *res;
	const char *abuf, *rbuf;
	STRLEN asiz;
	int i, num, rsiz;
#line 5253 "TokyoCabinet.c"

	STMT_START {
		SV* const xsub_tmp_sv = ST(2);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    args = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"TokyoCabinet::adb_misc",
				"args");
		}
	} STMT_END
;
#line 2693 "TokyoCabinet.xs"
	targs = tclistnew();
	num = av_len(args) + 1;
	for(i = 0; i < num; i++){
	  arg = *av_fetch(args, i, 0);
	  abuf = SvPV(arg, asiz);
	  tclistpush(targs, abuf, (int)asiz);
	}
	res = tcadbmisc(adb, name, targs);
	tclistdel(targs);
	if(res){
	  av = newAV();
	  for(i = 0; i < tclistnum(res); i++){
	    rbuf = tclistval(res, i, &rsiz);
	    av_push(av, newSVpvn(rbuf, rsiz));
	  }
	  tclistdel(res);
	  XPUSHs(sv_2mortal(newRV_noinc((SV *)av)));
	} else {
	  XPUSHs((SV *)&PL_sv_undef);
	}
	XSRETURN(1);
#line 5290 "TokyoCabinet.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_TokyoCabinet); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_TokyoCabinet)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("TokyoCabinet::tc_version", XS_TokyoCabinet_tc_version);
        newXS_deffile("TokyoCabinet::tc_atoi", XS_TokyoCabinet_tc_atoi);
        newXS_deffile("TokyoCabinet::tc_atof", XS_TokyoCabinet_tc_atof);
        newXS_deffile("TokyoCabinet::tc_bercompress", XS_TokyoCabinet_tc_bercompress);
        newXS_deffile("TokyoCabinet::tc_beruncompress", XS_TokyoCabinet_tc_beruncompress);
        newXS_deffile("TokyoCabinet::tc_diffcompress", XS_TokyoCabinet_tc_diffcompress);
        newXS_deffile("TokyoCabinet::tc_diffuncompress", XS_TokyoCabinet_tc_diffuncompress);
        newXS_deffile("TokyoCabinet::tc_strdistance", XS_TokyoCabinet_tc_strdistance);
        newXS_deffile("TokyoCabinet::hdb_new", XS_TokyoCabinet_hdb_new);
        newXS_deffile("TokyoCabinet::hdb_del", XS_TokyoCabinet_hdb_del);
        newXS_deffile("TokyoCabinet::hdb_errmsg", XS_TokyoCabinet_hdb_errmsg);
        newXS_deffile("TokyoCabinet::hdb_ecode", XS_TokyoCabinet_hdb_ecode);
        newXS_deffile("TokyoCabinet::hdb_tune", XS_TokyoCabinet_hdb_tune);
        newXS_deffile("TokyoCabinet::hdb_setcache", XS_TokyoCabinet_hdb_setcache);
        newXS_deffile("TokyoCabinet::hdb_setxmsiz", XS_TokyoCabinet_hdb_setxmsiz);
        newXS_deffile("TokyoCabinet::hdb_setdfunit", XS_TokyoCabinet_hdb_setdfunit);
        newXS_deffile("TokyoCabinet::hdb_open", XS_TokyoCabinet_hdb_open);
        newXS_deffile("TokyoCabinet::hdb_close", XS_TokyoCabinet_hdb_close);
        newXS_deffile("TokyoCabinet::hdb_put", XS_TokyoCabinet_hdb_put);
        newXS_deffile("TokyoCabinet::hdb_putkeep", XS_TokyoCabinet_hdb_putkeep);
        newXS_deffile("TokyoCabinet::hdb_putcat", XS_TokyoCabinet_hdb_putcat);
        newXS_deffile("TokyoCabinet::hdb_putasync", XS_TokyoCabinet_hdb_putasync);
        newXS_deffile("TokyoCabinet::hdb_out", XS_TokyoCabinet_hdb_out);
        newXS_deffile("TokyoCabinet::hdb_get", XS_TokyoCabinet_hdb_get);
        newXS_deffile("TokyoCabinet::hdb_vsiz", XS_TokyoCabinet_hdb_vsiz);
        newXS_deffile("TokyoCabinet::hdb_iterinit", XS_TokyoCabinet_hdb_iterinit);
        newXS_deffile("TokyoCabinet::hdb_iternext", XS_TokyoCabinet_hdb_iternext);
        newXS_deffile("TokyoCabinet::hdb_fwmkeys", XS_TokyoCabinet_hdb_fwmkeys);
        newXS_deffile("TokyoCabinet::hdb_addint", XS_TokyoCabinet_hdb_addint);
        newXS_deffile("TokyoCabinet::hdb_adddouble", XS_TokyoCabinet_hdb_adddouble);
        newXS_deffile("TokyoCabinet::hdb_sync", XS_TokyoCabinet_hdb_sync);
        newXS_deffile("TokyoCabinet::hdb_optimize", XS_TokyoCabinet_hdb_optimize);
        newXS_deffile("TokyoCabinet::hdb_vanish", XS_TokyoCabinet_hdb_vanish);
        newXS_deffile("TokyoCabinet::hdb_copy", XS_TokyoCabinet_hdb_copy);
        newXS_deffile("TokyoCabinet::hdb_tranbegin", XS_TokyoCabinet_hdb_tranbegin);
        newXS_deffile("TokyoCabinet::hdb_trancommit", XS_TokyoCabinet_hdb_trancommit);
        newXS_deffile("TokyoCabinet::hdb_tranabort", XS_TokyoCabinet_hdb_tranabort);
        newXS_deffile("TokyoCabinet::hdb_path", XS_TokyoCabinet_hdb_path);
        newXS_deffile("TokyoCabinet::hdb_rnum", XS_TokyoCabinet_hdb_rnum);
        newXS_deffile("TokyoCabinet::hdb_fsiz", XS_TokyoCabinet_hdb_fsiz);
        newXS_deffile("TokyoCabinet::bdb_new", XS_TokyoCabinet_bdb_new);
        newXS_deffile("TokyoCabinet::bdb_del", XS_TokyoCabinet_bdb_del);
        newXS_deffile("TokyoCabinet::bdb_errmsg", XS_TokyoCabinet_bdb_errmsg);
        newXS_deffile("TokyoCabinet::bdb_ecode", XS_TokyoCabinet_bdb_ecode);
        newXS_deffile("TokyoCabinet::bdb_setcmpfunc", XS_TokyoCabinet_bdb_setcmpfunc);
        newXS_deffile("TokyoCabinet::bdb_setcmpfuncex", XS_TokyoCabinet_bdb_setcmpfuncex);
        newXS_deffile("TokyoCabinet::bdb_tune", XS_TokyoCabinet_bdb_tune);
        newXS_deffile("TokyoCabinet::bdb_setcache", XS_TokyoCabinet_bdb_setcache);
        newXS_deffile("TokyoCabinet::bdb_setxmsiz", XS_TokyoCabinet_bdb_setxmsiz);
        newXS_deffile("TokyoCabinet::bdb_setdfunit", XS_TokyoCabinet_bdb_setdfunit);
        newXS_deffile("TokyoCabinet::bdb_open", XS_TokyoCabinet_bdb_open);
        newXS_deffile("TokyoCabinet::bdb_close", XS_TokyoCabinet_bdb_close);
        newXS_deffile("TokyoCabinet::bdb_put", XS_TokyoCabinet_bdb_put);
        newXS_deffile("TokyoCabinet::bdb_putkeep", XS_TokyoCabinet_bdb_putkeep);
        newXS_deffile("TokyoCabinet::bdb_putcat", XS_TokyoCabinet_bdb_putcat);
        newXS_deffile("TokyoCabinet::bdb_putdup", XS_TokyoCabinet_bdb_putdup);
        newXS_deffile("TokyoCabinet::bdb_putlist", XS_TokyoCabinet_bdb_putlist);
        newXS_deffile("TokyoCabinet::bdb_out", XS_TokyoCabinet_bdb_out);
        newXS_deffile("TokyoCabinet::bdb_outlist", XS_TokyoCabinet_bdb_outlist);
        newXS_deffile("TokyoCabinet::bdb_get", XS_TokyoCabinet_bdb_get);
        newXS_deffile("TokyoCabinet::bdb_getlist", XS_TokyoCabinet_bdb_getlist);
        newXS_deffile("TokyoCabinet::bdb_vnum", XS_TokyoCabinet_bdb_vnum);
        newXS_deffile("TokyoCabinet::bdb_vsiz", XS_TokyoCabinet_bdb_vsiz);
        newXS_deffile("TokyoCabinet::bdb_range", XS_TokyoCabinet_bdb_range);
        newXS_deffile("TokyoCabinet::bdb_fwmkeys", XS_TokyoCabinet_bdb_fwmkeys);
        newXS_deffile("TokyoCabinet::bdb_addint", XS_TokyoCabinet_bdb_addint);
        newXS_deffile("TokyoCabinet::bdb_adddouble", XS_TokyoCabinet_bdb_adddouble);
        newXS_deffile("TokyoCabinet::bdb_sync", XS_TokyoCabinet_bdb_sync);
        newXS_deffile("TokyoCabinet::bdb_optimize", XS_TokyoCabinet_bdb_optimize);
        newXS_deffile("TokyoCabinet::bdb_vanish", XS_TokyoCabinet_bdb_vanish);
        newXS_deffile("TokyoCabinet::bdb_copy", XS_TokyoCabinet_bdb_copy);
        newXS_deffile("TokyoCabinet::bdb_tranbegin", XS_TokyoCabinet_bdb_tranbegin);
        newXS_deffile("TokyoCabinet::bdb_trancommit", XS_TokyoCabinet_bdb_trancommit);
        newXS_deffile("TokyoCabinet::bdb_tranabort", XS_TokyoCabinet_bdb_tranabort);
        newXS_deffile("TokyoCabinet::bdb_path", XS_TokyoCabinet_bdb_path);
        newXS_deffile("TokyoCabinet::bdb_rnum", XS_TokyoCabinet_bdb_rnum);
        newXS_deffile("TokyoCabinet::bdb_fsiz", XS_TokyoCabinet_bdb_fsiz);
        newXS_deffile("TokyoCabinet::bdbcur_new", XS_TokyoCabinet_bdbcur_new);
        newXS_deffile("TokyoCabinet::bdbcur_del", XS_TokyoCabinet_bdbcur_del);
        newXS_deffile("TokyoCabinet::bdbcur_first", XS_TokyoCabinet_bdbcur_first);
        newXS_deffile("TokyoCabinet::bdbcur_last", XS_TokyoCabinet_bdbcur_last);
        newXS_deffile("TokyoCabinet::bdbcur_jump", XS_TokyoCabinet_bdbcur_jump);
        newXS_deffile("TokyoCabinet::bdbcur_prev", XS_TokyoCabinet_bdbcur_prev);
        newXS_deffile("TokyoCabinet::bdbcur_next", XS_TokyoCabinet_bdbcur_next);
        newXS_deffile("TokyoCabinet::bdbcur_put", XS_TokyoCabinet_bdbcur_put);
        newXS_deffile("TokyoCabinet::bdbcur_out", XS_TokyoCabinet_bdbcur_out);
        newXS_deffile("TokyoCabinet::bdbcur_key", XS_TokyoCabinet_bdbcur_key);
        newXS_deffile("TokyoCabinet::bdbcur_val", XS_TokyoCabinet_bdbcur_val);
        newXS_deffile("TokyoCabinet::fdb_new", XS_TokyoCabinet_fdb_new);
        newXS_deffile("TokyoCabinet::fdb_del", XS_TokyoCabinet_fdb_del);
        newXS_deffile("TokyoCabinet::fdb_errmsg", XS_TokyoCabinet_fdb_errmsg);
        newXS_deffile("TokyoCabinet::fdb_ecode", XS_TokyoCabinet_fdb_ecode);
        newXS_deffile("TokyoCabinet::fdb_tune", XS_TokyoCabinet_fdb_tune);
        newXS_deffile("TokyoCabinet::fdb_open", XS_TokyoCabinet_fdb_open);
        newXS_deffile("TokyoCabinet::fdb_close", XS_TokyoCabinet_fdb_close);
        newXS_deffile("TokyoCabinet::fdb_put", XS_TokyoCabinet_fdb_put);
        newXS_deffile("TokyoCabinet::fdb_putkeep", XS_TokyoCabinet_fdb_putkeep);
        newXS_deffile("TokyoCabinet::fdb_putcat", XS_TokyoCabinet_fdb_putcat);
        newXS_deffile("TokyoCabinet::fdb_out", XS_TokyoCabinet_fdb_out);
        newXS_deffile("TokyoCabinet::fdb_get", XS_TokyoCabinet_fdb_get);
        newXS_deffile("TokyoCabinet::fdb_vsiz", XS_TokyoCabinet_fdb_vsiz);
        newXS_deffile("TokyoCabinet::fdb_iterinit", XS_TokyoCabinet_fdb_iterinit);
        newXS_deffile("TokyoCabinet::fdb_iternext", XS_TokyoCabinet_fdb_iternext);
        newXS_deffile("TokyoCabinet::fdb_range", XS_TokyoCabinet_fdb_range);
        newXS_deffile("TokyoCabinet::fdb_addint", XS_TokyoCabinet_fdb_addint);
        newXS_deffile("TokyoCabinet::fdb_adddouble", XS_TokyoCabinet_fdb_adddouble);
        newXS_deffile("TokyoCabinet::fdb_sync", XS_TokyoCabinet_fdb_sync);
        newXS_deffile("TokyoCabinet::fdb_optimize", XS_TokyoCabinet_fdb_optimize);
        newXS_deffile("TokyoCabinet::fdb_vanish", XS_TokyoCabinet_fdb_vanish);
        newXS_deffile("TokyoCabinet::fdb_copy", XS_TokyoCabinet_fdb_copy);
        newXS_deffile("TokyoCabinet::fdb_tranbegin", XS_TokyoCabinet_fdb_tranbegin);
        newXS_deffile("TokyoCabinet::fdb_trancommit", XS_TokyoCabinet_fdb_trancommit);
        newXS_deffile("TokyoCabinet::fdb_tranabort", XS_TokyoCabinet_fdb_tranabort);
        newXS_deffile("TokyoCabinet::fdb_path", XS_TokyoCabinet_fdb_path);
        newXS_deffile("TokyoCabinet::fdb_rnum", XS_TokyoCabinet_fdb_rnum);
        newXS_deffile("TokyoCabinet::fdb_fsiz", XS_TokyoCabinet_fdb_fsiz);
        newXS_deffile("TokyoCabinet::tdb_new", XS_TokyoCabinet_tdb_new);
        newXS_deffile("TokyoCabinet::tdb_del", XS_TokyoCabinet_tdb_del);
        newXS_deffile("TokyoCabinet::tdb_errmsg", XS_TokyoCabinet_tdb_errmsg);
        newXS_deffile("TokyoCabinet::tdb_ecode", XS_TokyoCabinet_tdb_ecode);
        newXS_deffile("TokyoCabinet::tdb_tune", XS_TokyoCabinet_tdb_tune);
        newXS_deffile("TokyoCabinet::tdb_setcache", XS_TokyoCabinet_tdb_setcache);
        newXS_deffile("TokyoCabinet::tdb_setxmsiz", XS_TokyoCabinet_tdb_setxmsiz);
        newXS_deffile("TokyoCabinet::tdb_setdfunit", XS_TokyoCabinet_tdb_setdfunit);
        newXS_deffile("TokyoCabinet::tdb_open", XS_TokyoCabinet_tdb_open);
        newXS_deffile("TokyoCabinet::tdb_close", XS_TokyoCabinet_tdb_close);
        newXS_deffile("TokyoCabinet::tdb_put", XS_TokyoCabinet_tdb_put);
        newXS_deffile("TokyoCabinet::tdb_putkeep", XS_TokyoCabinet_tdb_putkeep);
        newXS_deffile("TokyoCabinet::tdb_putcat", XS_TokyoCabinet_tdb_putcat);
        newXS_deffile("TokyoCabinet::tdb_out", XS_TokyoCabinet_tdb_out);
        newXS_deffile("TokyoCabinet::tdb_get", XS_TokyoCabinet_tdb_get);
        newXS_deffile("TokyoCabinet::tdb_vsiz", XS_TokyoCabinet_tdb_vsiz);
        newXS_deffile("TokyoCabinet::tdb_iterinit", XS_TokyoCabinet_tdb_iterinit);
        newXS_deffile("TokyoCabinet::tdb_iternext", XS_TokyoCabinet_tdb_iternext);
        newXS_deffile("TokyoCabinet::tdb_fwmkeys", XS_TokyoCabinet_tdb_fwmkeys);
        newXS_deffile("TokyoCabinet::tdb_addint", XS_TokyoCabinet_tdb_addint);
        newXS_deffile("TokyoCabinet::tdb_adddouble", XS_TokyoCabinet_tdb_adddouble);
        newXS_deffile("TokyoCabinet::tdb_sync", XS_TokyoCabinet_tdb_sync);
        newXS_deffile("TokyoCabinet::tdb_optimize", XS_TokyoCabinet_tdb_optimize);
        newXS_deffile("TokyoCabinet::tdb_vanish", XS_TokyoCabinet_tdb_vanish);
        newXS_deffile("TokyoCabinet::tdb_copy", XS_TokyoCabinet_tdb_copy);
        newXS_deffile("TokyoCabinet::tdb_tranbegin", XS_TokyoCabinet_tdb_tranbegin);
        newXS_deffile("TokyoCabinet::tdb_trancommit", XS_TokyoCabinet_tdb_trancommit);
        newXS_deffile("TokyoCabinet::tdb_tranabort", XS_TokyoCabinet_tdb_tranabort);
        newXS_deffile("TokyoCabinet::tdb_path", XS_TokyoCabinet_tdb_path);
        newXS_deffile("TokyoCabinet::tdb_rnum", XS_TokyoCabinet_tdb_rnum);
        newXS_deffile("TokyoCabinet::tdb_fsiz", XS_TokyoCabinet_tdb_fsiz);
        newXS_deffile("TokyoCabinet::tdb_setindex", XS_TokyoCabinet_tdb_setindex);
        newXS_deffile("TokyoCabinet::tdb_genuid", XS_TokyoCabinet_tdb_genuid);
        newXS_deffile("TokyoCabinet::tdbqry_new", XS_TokyoCabinet_tdbqry_new);
        newXS_deffile("TokyoCabinet::tdbqry_del", XS_TokyoCabinet_tdbqry_del);
        newXS_deffile("TokyoCabinet::tdbqry_addcond", XS_TokyoCabinet_tdbqry_addcond);
        newXS_deffile("TokyoCabinet::tdbqry_setorder", XS_TokyoCabinet_tdbqry_setorder);
        newXS_deffile("TokyoCabinet::tdbqry_setlimit", XS_TokyoCabinet_tdbqry_setlimit);
        newXS_deffile("TokyoCabinet::tdbqry_search", XS_TokyoCabinet_tdbqry_search);
        newXS_deffile("TokyoCabinet::tdbqry_searchout", XS_TokyoCabinet_tdbqry_searchout);
        newXS_deffile("TokyoCabinet::tdbqry_proc", XS_TokyoCabinet_tdbqry_proc);
        newXS_deffile("TokyoCabinet::tdbqry_hint", XS_TokyoCabinet_tdbqry_hint);
        newXS_deffile("TokyoCabinet::tdbqry_metasearch", XS_TokyoCabinet_tdbqry_metasearch);
        newXS_deffile("TokyoCabinet::tdbqry_kwic", XS_TokyoCabinet_tdbqry_kwic);
        newXS_deffile("TokyoCabinet::adb_new", XS_TokyoCabinet_adb_new);
        newXS_deffile("TokyoCabinet::adb_del", XS_TokyoCabinet_adb_del);
        newXS_deffile("TokyoCabinet::adb_open", XS_TokyoCabinet_adb_open);
        newXS_deffile("TokyoCabinet::adb_close", XS_TokyoCabinet_adb_close);
        newXS_deffile("TokyoCabinet::adb_put", XS_TokyoCabinet_adb_put);
        newXS_deffile("TokyoCabinet::adb_putkeep", XS_TokyoCabinet_adb_putkeep);
        newXS_deffile("TokyoCabinet::adb_putcat", XS_TokyoCabinet_adb_putcat);
        newXS_deffile("TokyoCabinet::adb_out", XS_TokyoCabinet_adb_out);
        newXS_deffile("TokyoCabinet::adb_get", XS_TokyoCabinet_adb_get);
        newXS_deffile("TokyoCabinet::adb_vsiz", XS_TokyoCabinet_adb_vsiz);
        newXS_deffile("TokyoCabinet::adb_iterinit", XS_TokyoCabinet_adb_iterinit);
        newXS_deffile("TokyoCabinet::adb_iternext", XS_TokyoCabinet_adb_iternext);
        newXS_deffile("TokyoCabinet::adb_fwmkeys", XS_TokyoCabinet_adb_fwmkeys);
        newXS_deffile("TokyoCabinet::adb_addint", XS_TokyoCabinet_adb_addint);
        newXS_deffile("TokyoCabinet::adb_adddouble", XS_TokyoCabinet_adb_adddouble);
        newXS_deffile("TokyoCabinet::adb_sync", XS_TokyoCabinet_adb_sync);
        newXS_deffile("TokyoCabinet::adb_optimize", XS_TokyoCabinet_adb_optimize);
        newXS_deffile("TokyoCabinet::adb_vanish", XS_TokyoCabinet_adb_vanish);
        newXS_deffile("TokyoCabinet::adb_copy", XS_TokyoCabinet_adb_copy);
        newXS_deffile("TokyoCabinet::adb_tranbegin", XS_TokyoCabinet_adb_tranbegin);
        newXS_deffile("TokyoCabinet::adb_trancommit", XS_TokyoCabinet_adb_trancommit);
        newXS_deffile("TokyoCabinet::adb_tranabort", XS_TokyoCabinet_adb_tranabort);
        newXS_deffile("TokyoCabinet::adb_path", XS_TokyoCabinet_adb_path);
        newXS_deffile("TokyoCabinet::adb_rnum", XS_TokyoCabinet_adb_rnum);
        newXS_deffile("TokyoCabinet::adb_size", XS_TokyoCabinet_adb_size);
        newXS_deffile("TokyoCabinet::adb_misc", XS_TokyoCabinet_adb_misc);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

